// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */


#ifndef __ALL_INIT__
#define __ALL_INIT__

#include <motor/sarme.hh>
#include <motor/model.hh>
#include <motor/texture.hh>

extern SAmo *MP40_Amo;
extern SAmo *STEIGNER_Amo;
extern SAmo *BROWNING_Amo;
extern SAmo *AK47_Amo;
extern SAmo *GRENADE_Amo;

static void init_arme()
{
	BROWNING_Amo	= new SAmo(SAmo::NINE_MM);
	MP40_Amo	= BROWNING_Amo;
	AK47_Amo	= new SAmo(SAmo::P50);
	GRENADE_Amo 	= new SAmo(SAmo::GRENADE);
}

static void clean_arme()
{
	if(GRENADE_Amo)
		delete GRENADE_Amo;
	if(AK47_Amo)	
		delete AK47_Amo;
	if(MP40_Amo)	
		delete MP40_Amo;
	if(BROWNING_Amo)	
		delete BROWNING_Amo;
}



extern Model *chaise1;
extern Model *monstre1; 
extern Model *table1;
extern Model *gun1; 
extern Model *lampe1;
extern Model *grenade1;
extern Md2Model* mod_md2;

static void init_model()
{
	chaise1	 = new Model("./models/chaise1.3ds");
	table1	 = new Model("./models/table1.3ds");
	monstre1 = new Model("./models/Marine.3ds");
	gun1	 = new Model("./models/gun_dep.3ds");
	lampe1	 = new Model("./models/lp_fix.3ds");
	grenade1 = new Model("./models/grenade.3ds"); 
	
	mod_md2  = new Md2Model();
	
	if(!mod_md2->loadModel("./models/monstre_1.md2"))
		cout << "ERROR WHILE LOADING MODELS" << endl;
}

static void clean_model()
{
	if(mod_md2)
		delete mod_md2;
	if(grenade1)
		delete grenade1;
	if(lampe1)
		delete lampe1;
	if(gun1)
		delete gun1;
	if(monstre1)
		delete monstre1;
	if(table1)
		delete table1;
	if(chaise1)
		delete chaise1;
}



extern TextureGL* tex_pt;
extern TextureGL* tex_name;
extern TextureGL* tex_port;
extern TextureGL* tex_gril;
extern TextureGL* tex_sol;
extern TextureGL* tex_plafon;

static void init_texture()
{
	tex_name=new TextureGL("./Textures/143.ppm");		     
	tex_port=new TextureGL("./Textures/porte1.ppm");	     
	tex_gril=new TextureGL("./Textures/grille_air2.ppm");
	tex_sol=new TextureGL("./Textures/sol2.ppm");
	tex_plafon=new TextureGL("./Textures/plafond.ppm");
}

static void clean_texture()
{
	if(tex_plafon)
		delete tex_plafon;
	if(tex_sol)		
		delete tex_sol;
	if(tex_gril)	
		delete tex_gril;
	if(tex_port)	
		delete tex_port;
	if(tex_name)	
		delete tex_name;
}



#endif
