// define.h v 1.0 09.2003 (mGC Library)
// Global definitions
// Copyright (C) 2003 L.E.R.I.  All rights reserved.
// Reims University (FRANCE)

#ifndef __DEFINE__
#define __DEFINE__

typedef unsigned char	UCHAR;
typedef unsigned short	USHORT;
typedef unsigned			UINT;
typedef unsigned long	ULONG;

#ifndef CCHAR
#define CCHAR const char
#endif

#ifndef EPS
#define EPS 			0.0008
#endif

#ifndef TIME_CORRECTION
#define TIME_CORRECTION 	0.1
#endif

#ifndef ACCELERATION_MIN
#define ACCELERATION_MIN	0.2
#endif	

#ifndef PI 
#define PI			3.1415926535897932	
#endif

#ifdef WIN32
       typedef unsigned long RGB;
       #define srandom srand
#else
     #ifndef RGB
     #define RGB unsigned long
     #endif
#endif

#define CLIP(a)   (((a)>255)?255:((a)<0?0:(a)))
#define MAX(a,b)	((a) > (b) ? (a) :  (b))
#define MIN(a,b)	((a) < (b) ? (a) :  (b))
#define ABS(a)		((a) >= 0  ? (a) : -(a))
#define SQ(a)		((a) * (a))
#define SWAP16(n) ((n)>>8 | (n)<<8)
#define SWAP32(n) ((n)>>8 | (n)<<8)

#define S_SPHERE_TYPE 	1
#define S_BOX_TYPE	2
#define S_LINE_TYPE	3
#define S_POINT_TYPE	4
#define S_CUBE_TYPE	5
#define S_CONE_TYPE	6
#define S_CYLINDRE_TYPE	7
#define S_TORUS_TYPE	8
#define S_PERSO_TYPE	9
#define S_ENTITY_TYPE	10
#define S_CAISSE_TYPE	11

#ifndef COLLISION
#define COLLISION	1
#endif

#ifndef COLLISION_NONE
#define COLLISION_NONE	0
#endif


inline int ROUND(double d)
{
    return d > 0.0 ? int(d+0.5) : int(d-0.5);
}

#endif // __DEFINE__
