// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */
 
 
 
#ifndef _HUD_H_
#define _HUD_H_

#include <list>
#include <GL/gl.h>


#include <motor/particle.hh>
#include <motor/real_obj.hh>
#include <motor/camera.hh>
#include <motor/sarme.hh>

using namespace mCG;

#define PARTICULE_NB 100

class HUD;

class HUD_Bar
{
	friend class HUD;
	protected:
		void update();
		HUD *Perso;
		
	public:
		HUD_Bar(HUD*);
		~HUD_Bar();
		
		void display();
};


///////////// Classe permettant la gestion du HUD ///////////////////////

class HUD
{
	friend class HUD_Bar;
	friend class Scene;
	
	protected:
		Particule*	parts;
		
		CameraFP*	cam;
		SArme*		objActif;
		GLfloat		angleX;
		list<SArme*> 	lObj;
		float 		life, armor;
		HUD_Bar 	*bar;
		SAmoStock 	*stock;
		bool 		helpActive;
			
		static void 	displayHelp();
		
	public:
		HUD();
		HUD(CameraFP*);
		~HUD();
		
		inline void setCamera(CameraFP* _c)// if we change cam, change the HUD to fix to it
		{ cam = _c;}
	
		void addObject(SArme*);		// Add something to the HUD interface
		void setActif(short);		// Set the active object by ID
		void setAction(bool);		// Are we shooting something ? (animation)
		void setHelpActif(bool);
		bool getHelpActif()const;
        bool IsAlive()const;
		SArme::SArmeType getArmeType() const;
        void Reload()const;
		
		void updatePosition();		// Following the camera
		void updateAction(float); 	// Is someone shoting  us ?
		void display();			// Need to display here the elements that compose the HUD
		void writeMsg(const char* msg, const Color& col=Color(1., 1., 1.)); // Write a message on the screen
};

#endif // _HUD_H_

