// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */


#ifndef __COLLISION__H__
#define __COLLISION__H__

#include <iostream>
#include <stdlib.h>
#include <GL/gl.h>
#include <list>

#include <algebra.h>
#include <motor/objet.hh>
#include <motor/real_obj.hh>
#include <motor/interaction.hh>

using namespace std;
using namespace mCG;

extern bool Box2BoxCollision(SBox*, SBox*);

/* --- Classes dedicated to the collision detection in 3D --- */

class SCollision
{
	public:
		virtual bool collisionDetected(const SInteraction&, const SPlan&) const = 0;
		virtual bool collisionDetected(const SInteraction&, const SLine&) const = 0;
		virtual bool collisionDetected(const SInteraction&, const SBox&) const = 0;
		virtual bool collisionDetected(const SInteraction&, const SSphere&) const = 0;
		virtual bool collisionDetected(const SInteraction&, const SPerso&) const = 0;
};


class SPlanBox : public SCollision
{
	public: 
		bool collisionDetected(const SInteraction&, const SPlan&) const;
		bool collisionDetected(const SInteraction&, const SLine&) const;
		bool collisionDetected(const SInteraction&, const SBox&) const;
		bool collisionDetected(const SInteraction&, const SSphere&) const;
		bool collisionDetected(const SInteraction&, const SPerso&) const;
};
		

class SPlanSphere : public SCollision
{
	public:
		bool collisionDetected(const SInteraction&, const SPlan&) const;
		bool collisionDetected(const SInteraction&, const SLine&) const;
		bool collisionDetected(const SInteraction&, const SBox&) const;
		bool collisionDetected(const SInteraction&, const SSphere&) const;
		bool collisionDetected(const SInteraction&, const SPerso&) const;
};

class SPersoCol : public SCollision
{
	public:
		bool collisionDetected(const SInteraction&, const SPlan&) const;
		bool collisionDetected(const SInteraction&, const SLine&) const;
		bool collisionDetected(const SInteraction&, const SBox&) const;
		bool collisionDetected(const SInteraction&, const SSphere&) const;
		bool collisionDetected(const SInteraction&, const SPerso&) const;
};



#endif /* __COLLISION__H__ */
