// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */


#ifndef __INTERACTION__H__
#define __INTERACTION__H__

#include <iostream>
#include <stdlib.h>
#include <GL/gl.h>
#include <list>

#include <algebra.h>
#include <motor/objet.hh>
#include <motor/real_obj.hh>

using namespace std;
using namespace mCG;

/* --- Class just to support the physical intercation --- */

class SInteraction
{
	friend class SCollision;
	friend class SPlanSphere;
	friend class SPlanBox;
	friend class SPersoCol;
	friend class Scene;
	
	protected:
		SObject** 	sObj;
		SEntity**	sEntity;
		vR3		sVt;
		pR3		sPt;
		pR3		sP0;
		double	 	sTime;
		double		delta_t;
		double		updateTime;
		
	public:
		SInteraction(SObject** obj);
		SInteraction(SEntity** obj);
		
		void setObj(SObject** _o);
		void		init();	
		pR3 		getCenter() const;
		vR3 		getSpeed() const;
		double	 	getExecTime() const;
		double		getDeltaTime() const;
		
		SObject*	onAction(const list<SObject*>, bool& inter_or_not, bool param=true);	
};	

#endif /* __INTERACTION__H__ */
