// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */


#ifndef _LUMIERE_H_
#define _LUMIERE_H_

#include <iostream>
#include <GL/gl.h>


#include <algebra.h>
#include <color.h>

using namespace std;
using namespace mCG;

class Lumiere
{
	protected:
		static int num;
		GLenum lightType;
		pR3 pos;
		Color couleur[3];		// Couleurs Diffuse, Ambient, Speculaire
		
	public:
		Lumiere();
		Lumiere(const pR3& p, Color* c);
		virtual ~Lumiere();
		
		void enable() const;
		void disable() const;
		
		void setPos(const pR3&);
		const pR3& getPos() const;
		
		virtual void init() = 0;
};
	
class LumiereDir : public Lumiere
{
	protected:
		vR3 dir;
	
	public:
		LumiereDir();
		LumiereDir(const pR3& p, Color* c, const vR3& v=vR3());
		~LumiereDir();
		
		void init();
		void setDir(const vR3&);
		const vR3& getDir() const;
};

class Spot : public Lumiere
{
	protected:
		GLfloat cutoff;
		GLfloat expo;
		vR3     dir;
		
	public:
		Spot();
		Spot(const pR3&, Color*, const float&, const float&, const vR3&);
		~Spot();
		
		void init();
		void setDir(const vR3&);
		const vR3& getDir() const;
};

#endif // _LUMIERE_H_
