// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */


#ifndef _MATERIAL_H_
#define _MATERIAL_H_

#include <GL/gl.h>

#include <algebra.h>
#include <color.h>

using namespace mCG;


class Material
{
	protected:
		GLfloat amb[4];
		GLfloat dif[4];
		GLfloat spe[4];
		GLfloat shi;
		GLfloat emi[4];
		
	public:
		Material();
		Material(GLfloat*, GLfloat*,GLfloat*, GLfloat, GLfloat*);
		Material(const Material&);
		~Material();
		
		Material& operator =(const Material&);
		
		void enable() const;
		void disable() const;
		
		void setAmbiant(const Color&);
		void setDiffuse(const Color&);
		void setSpecular(const Color&);
		void setEmission(const Color&);
		void setShininess(const GLfloat&);
};


#endif // _MATERIAL_H_
