// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */
 
 
#ifndef _PARTICULE_H_
#define _PARTICULE_H_

#include <GL/gl.h>

#include <define.h>
#include <algebra.h>
#include <color.h>
#include <loadppm.hh>
#include <motor/texture.hh>

extern TextureGL* tex_pt;
extern  textureImage *textim_pt;

using namespace mCG;

class Particule
{
	public:
		bool 	active;
		bool    explo;
		GLuint  num;
		GLfloat	life;
		GLfloat fade;
		Color	color;
		pR3 	pos;
		vR3 	speed;
		vR3 	gravity;
//		TextureGL* tex;
	public:
		Particule();
		Particule(const GLfloat&, const GLfloat&, const char* _tex = NULL, const Color& col=Color());
		~Particule();
		
		void setActive(bool);
		void setLife(const GLfloat&);
		void setFade(const GLfloat&);
		void setPos(const pR3&);
		void setSpeed(const vR3& p);
		void setGravity(const vR3&);
	//	void setTexture(const char*);
		
		bool 		isActive() const;
		const GLfloat& 	getLife() const;
		const GLfloat& 	getFade() const;
		const pR3& 	getPos() const;
		const vR3& 	getSpeed() const;
		const vR3& 	getGravity() const;
		
		void update(const double&, const Color& new_color);
		void display();
		void loadGLTextures();
		void explode();
};

#endif // _PARTICULE_H_
