// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */


#ifndef _SARME_H_
#define _SARME_H_

#include <motor/real_obj.hh>


class SAmo
{

	public:
		enum SpecAmoType{ NORM, EXP, BLIND,PLASTIC};
		enum SAmoType   { NINE_MM, C12, PANZER, P50, SEVEN65, GRENADE};
	private:
		SAmoType type;
		GLfloat porte;
		SpecAmoType specType;	
	public:
		SAmo(SAmoType ,SpecAmoType t=NORM);
		SAmo(const SAmo&);
		~SAmo();
		
		SAmoType getType()const;
		GLfloat getPorte()const;
		GLfloat getSpecAmoType()const;
		void setSpecAmoType(SpecAmoType t=NORM);
};

extern SAmo* MP40_Amo;
extern SAmo* STEIGNER_Amo;
extern SAmo* BROWNING_Amo;
extern SAmo* AK47_Amo;
extern SAmo* GRENADE_Amo;

class SArme : public SEntity
{
	friend class HUD;
	friend class HUD_Bar;
	
	public:
		enum SArmeType { MP40, STEIGNER, BROWNING, STERN, UZI, AK47, WPPK, BAZOOKA, LUGER, GRENADE, UNDEFINED};
		
	private:
		GLfloat cap_vise;
		GLfloat *fact_porte;
		short *nb_amo; 
		short *amo_caps;
		GLfloat *cadence;
		SAmo *amo_used;
		SArmeType type;
		bool inActionUp , inActionDown, fire ;

	public:
		
		SArme(SArmeType);
		SArme(const SArme&);
		~SArme();
		void Reload(short& nb_rech,bool num=true);
		void Fire(short& nb_rech,bool,bool num=true);
		void Viser();
		
		GLfloat getVise()const;
		short getNbAmo(bool num=true)const;
		short getAmoCaps(bool num=true)const;
		GLfloat getCadence(bool num=true)const;
		SAmo::SAmoType getAmoType(bool num=true) const;
		SArmeType getArmeType() const;
};


class SAmoBox: public SCaisse
{
	public:
		enum SAmoBoxSize { LITTLE=20, MEDIUM=50, BIG=100 };
	
	private:
		short nb_amo;
		SAmo *amo;
	public:
		SAmoBox(SAmoBoxSize);
		~SAmoBox();
		short getNbAmo()const;
		SAmo* getAmo()const;
};


class SAmoStock
{
	friend class HUD;
	friend class HUD_Bar;
	
	protected:
		enum SAmoType { NINE_MM, C12,PANZER,GREN,P50,SEVEN65 };
		
		short NB_NINE_MM,
			NB_C12,
			NB_PANZER,
			NB_GREN,
			NB_P50,
			NB_SEVEN65;
	
	
	public:
		SAmoStock();
		~SAmoStock();
		

};


#endif
