// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */


#ifndef __TEXTURE_H__ 
#define __TEXTURE_H__ 

#include <GL/glut.h>


#include <loadppm.hh>


using namespace std;


class TextureGL
{
	private:
		GLenum wraps, wrapt;
		GLuint num;
	public:
		TextureGL() : num(0) {}
		TextureGL(GLuint _n) : num(_n)
		{
			glBindTexture( GL_TEXTURE_2D, num);
		}
		
		TextureGL(const TextureGL& src)
		{
			num = src.num;
			
			glBindTexture(GL_TEXTURE_2D, num);
   			
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
   			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
   			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
   			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		}
		
		TextureGL(const char* nom_fichier, GLenum ws=GL_REPEAT, GLenum wt=GL_REPEAT) : num(1), wraps(ws), wrapt(wt)
		{
			PPMImage *image = new PPMImage( nom_fichier );
			glGenTextures(1, &num);
			
			glBindTexture( GL_TEXTURE_2D, num );
			glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
			//gluBuild2DMipmaps(GL_TEXTURE_2D, 3, image->sizeX, image->sizeY,	GL_RGB, GL_UNSIGNED_BYTE, image->data);

			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
   			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
   			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
   			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
			glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
			gluBuild2DMipmaps(GL_TEXTURE_2D, 3, image->sizeX, image->sizeY,	GL_RGB, GL_UNSIGNED_BYTE, image->data);
            
			if(image)
				delete image;
		}
		
		
		~TextureGL()
		{
			glBindTexture( GL_TEXTURE_2D, 0 );
			glDeleteTextures(1, &num);
		}
		
		void desactiver()
		{
			//glDisable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, 0);
			//glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		}
		
		
		void activer(GLfloat Mode = GL_DECAL)
		{				
		//	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
			glEnable(GL_TEXTURE_2D);
			glBindTexture( GL_TEXTURE_2D, num);
		}
		
		GLuint getNum() const { return num; }
		
};

#endif //__TEXTURE_H__ 
