// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */


#ifndef _SERVEUR_H
#define _SERVEUR_H

#include <list>
#include <pthread.h>
#include <setjmp.h>
#include <errno.h>
#include <iostream>

/* Network includes */
#ifdef WIN32
#include <winsock2.h>
#else
#include <sys/socket.h>
#include <netdb.h>
#include <arpa/inet.h>
#endif

using namespace std;

static sigjmp_buf contexte;
extern int errno;

class Serveur
{
	public:
		class Client
		{
			public:
				float ID;
				int Sock;
				pthread_mutex_t *Sock_mutex;
				
				Client():ID(),Sock()
				{
					Sock_mutex=new pthread_mutex_t();
					pthread_mutex_init(Sock_mutex,NULL);
				}

				Client(float _id,int _sock):ID(_id),Sock(_sock)
				{
				     Sock_mutex=new pthread_mutex_t();
				     pthread_mutex_init(Sock_mutex,NULL);
				}
				
				~Client()
				{
					pthread_mutex_destroy(Sock_mutex);
					delete Sock_mutex;
					close(Sock);
				}
				
				inline bool operator == (const Client &t)const
				{	return ( t.ID == ID && t.Sock==Sock && t.Sock_mutex == Sock_mutex );	}
		};

		struct transmis
		{
			Client* _cli;
			Serveur* _serv;
		};
		
		
	private:
		list<Client*> all_cli;
		pthread_mutex_t *mut_cli,*mutex_thread , *mutex_id ;
		list<pthread_t> threads;  
		float id_cour;
		int port,sock;
		struct sockaddr_in adresse;


		/*		  Signal handler	  */
		inline static void rec_sig (int)
		{  siglongjmp(contexte,1);}
		/****************************************/
		
	
      public:
		Serveur();
		Serveur(const int&);		  
		~Serveur();

		bool init();
		bool start();
		void stop();
		void _close();
		
		void add(float,int); 
		void del(float _id);
		static void* Create_Thread(void*);
		
		const list<int> getAllOtherSock(float _id)const;
		const list<float> getAllID()const;
		const int getSocket(float _id)const;
		pthread_mutex_t* getMutex(float _id)const;
};



#endif



