// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */


#include <list>


#include <motor/allbullet.hh>


AllBullet::AllBullet():bullets(),interact()
{}

AllBullet::~AllBullet()
{
	if(bullets.size()>0)
	{
		for(list<SObject*>::iterator it=bullets.begin();it!=bullets.end();it++)
			delete (*it);
		bullets.clear();
	}
	
	if(interact.size()>0)
	{
		for(list<SInteraction*>::iterator it=interact.begin();it!=interact.end();it++)
			delete (*it);
		interact.clear();
	}
}

void AllBullet::addBullet()
{
/*	balle	= new SBox(0.01, 0.01, 0.01, Color(0.75, 0.47, 0.29), pR3(0., 0., 0.));
	balleMonst	= new SBox(0.02, 0.02, 0.02, Color(0.75, 0.47, 0.29), pR3(0., 0., 0.));
*/
	SObject* bul=new SBox(0.01, 0.01, 0.01, Color(0.75, 0.47, 0.29), pR3(0., 0., 0.));
	
	bul->setV0(vR3(0., 0., 0.));
	bul->setMass(5.);
	bul->setDensity(0.0);
	
	bullets.push_back(bul);
	SInteraction* inte=new SInteraction(&bul);
	inte->init();
	interact.push_back(inte);
}



unsigned short AllBullet::onAction(list<SObject*> enemy)
{
	bool nullbool(false);
	unsigned short touched(0);
	list<SObject*>::iterator it2=bullets.begin();
	int i=0;
	for(list<SInteraction*>::iterator it=interact.begin();it!=interact.end(), it2!=bullets.end();it++,it2++,i++)
	{
		(*it)->onAction(enemy, nullbool, false);
		if(nullbool)
		{			
			touched++;
		/*	interact.erase(it);
			delete (*it);
			bullets.erase(it2);
			delete (*it2);*/
		}
	}
	return touched;

}

void AllBullet::removeBullet(int)
{
	
	if(bullets.size())
	{
		for(list<SObject*>::iterator it=bullets.begin();it!=bullets.end();it++)
			delete (*it);
		bullets.clear();
	}
	
	if(interact.size())
	{
		for(list<SInteraction*>::iterator it=interact.begin();it!=interact.end();it++)
			delete (*it);
		interact.clear();
	}
}


void AllBullet::updatePosition(const pR3& orig_cam,const vR3& nn)
{
	if(bullets.size() && interact.size())
	{
		list<SObject*>::reverse_iterator it=bullets.rbegin();
		list<SInteraction*>::reverse_iterator it2=interact.rbegin();
		(*it)->updatePosition(orig_cam);
		(*it)->setV0(nn);
		(*it2)->setObj( &(*it) );
		(*it2)->init();
	}
}

void AllBullet::display() const
{
	for(list<SObject*>::const_iterator it=bullets.begin();it!=bullets.end();it++)
		(*it)->display();
}
