// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */


#include <motor/animation.hh>

Animation::Animation()
{
	pGun = NULL;
}

Animation::Animation(SArme* gun)
{
	pGun = gun;
}

Animation::~Animation()
{
	pGun = NULL;
}

AnimGrenScene::AnimGrenScene() : explosed(false), Animation()
{
	parts = new Particule[FRAG_EXPL];
	
	for(int i(0);i<FRAG_EXPL;i++)
	{
		*(parts+i) = Particule(1.5, (float)(rand() % 100) / 1000 + 0.003f, NULL , Color(0.95, 0.67, 0.49));
		(parts+i)->setSpeed(vR3((float)((rand() % 50) - 26.0f) * 10.0f,(float) ((rand() % 50) - 25.0f) * 10.0f, (float)((rand() % 50) - 25.0f) * 10.0f));
		(parts+i)->setGravity(vR3(0., 0.5, 0.));
	}
	
	start = time(0);
}

AnimGrenScene::AnimGrenScene(SArme* gun) : explosed(false), Animation(gun)
{
	parts = new Particule[FRAG_EXPL];
	
	for(int i(0);i<FRAG_EXPL;i++)
	{
		*(parts+i) = Particule(1.5, (float)(rand() % 100) / 1000 + 0.003f, NULL , Color(0.95, 0.67, 0.49));
		(parts+i)->setSpeed(vR3((float)((rand() % 50) - 26.0f) * 10.0f,(float) ((rand() % 50) - 25.0f) * 10.0f, (float)((rand() % 50) - 25.0f) * 10.0f));
		(parts+i)->setGravity(vR3(0., 0.5, 0.));
	}
	
	start = time(0);
}

AnimGrenScene::~AnimGrenScene()
{
	if(parts)
		delete[] parts;
	parts = NULL;
}
		
void AnimGrenScene::activate()
{
	if(pGun)
	{
		pGun->setVisible(false);
		pGun->setAnimated(false);
		pGun->boundingBox()->setAnimated(false);
	
		for(int i(0);i<FRAG_EXPL;i++)
			(parts+i)->explode();
	}
}


SArme* AnimGrenScene::display()
{
	time_t inter = time(0);
	double diff  = difftime(inter, start);
	
	if(diff > 3 && !explosed)
	{
		explosed = true;
		activate();
	}
	
	if(pGun && explosed && diff < 5)
	{
		bool is_col(false);
		pR3 mc(pGun->boundingBox()->getMassCenter());
		
		glPushMatrix();
			glTranslatef(mc.x, mc.y, mc.z);
			for(int i(0);i<FRAG_EXPL;i++)
			{
				(parts+i)->display();
				(parts+i)->update(1.5, Color(0.75, 0.47, 0.29));
			}
		glPopMatrix();
	}
	
	if(diff >= 5)
		return pGun;
	
	return 0;
}
