// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */



#include <motor/camera.hh>

using namespace std;


//////////////////////////////////////////////////////////////////////////////////
 
   
   CameraFP::CameraFP() : Camera()
   {
	   box = new SBox(5., 15., 2., Color(1., 0., 0.), Oeil);
	   box->setV0(Viser);
	   box->setMass(0.5);
	   box->setDensity(0.01);
   }
   
   CameraFP::CameraFP(const CameraFP& cam) : Camera((Camera)cam)
   {
	   box = new SBox(5., 15., 2., Color(1., 0., 0.), Oeil);
	   box->setV0(Viser);
	   box->setMass(0.5);
	   box->setDensity(0.01);
   }
   
   CameraFP::~CameraFP()
   {
	   if(box)
		   delete box;
	   box = NULL;
   }
   
   CameraFP& CameraFP::operator =(const CameraFP& cam)
   {
	   Oeil = cam.Oeil;
	   Viser = cam.Viser;
	   x = cam.x;
	   y = cam.y;
	   
	   box = new SBox(5., 15., 2., Color(1., 0., 0.), Oeil);
	   box->setV0(Viser);
	   box->setMass(0.5);
	   box->setDensity(0.01);
   }

    
    	void CameraFP::Display()
	{
		Camera::Display();
    	}
    
   void CameraFP::Motion(int _x, int _y)
   {
	Camera::Motion(_x, _y);
	
	box->setV0(Viser);
	box->updatePosition(Oeil);
   }
   
   void CameraFP::Keyboard( unsigned int key, int _x, int _y )
   {
       	Camera::Keyboard(key, _x, _y);

       	pR3 pos_cam(Oeil);
	pos_cam.y-=7.;
       	box->setV0(Viser);
	box->updatePosition(pos_cam);
   }
   
   void CameraFP::KeyboardInv( unsigned int key, int _x, int _y )
   {
	switch (key)
	{
		case '8': Oeil.x -= 10.5*Viser.x / 2.5; Oeil.z -= 10.5*Viser.z / 2.5; break;
		case '2': Oeil.x += 10.5*Viser.x / 2.5; Oeil.z += 10.5*Viser.z / 2.5;  break;
       	 	default : break;   
       	}
	
       	pR3 pos_cam(Oeil);
	pos_cam.y-=7.;
       	box->setV0(Viser);
	box->updatePosition(pos_cam);	
   }
  
