// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */

#ifdef LINUX
#include <GL/glut.h>
#endif

#include <errno.h>
#include <signal.h>
#include <unistd.h>
#include <pthread.h>


#include <motor/scene.hh>
#include <network/client.h> //definition de la fonction Client_Reseau
#include <network/serveur.hh>

//#include <all_init.h> //definition et fonction d'initialisation pour
			// les armes, models et textures
			
using namespace std;


Scene* scene_principale = NULL;


SEntity* entite2Add 	= NULL;
SMonstre* monstre2Add 	= NULL;
SArme* arme2add     	= NULL;

textureImage *textim_pt = NULL;
SEntity* ent_md2	= NULL;


SAmo *MP40_Amo		= NULL;
SAmo *STEIGNER_Amo	= NULL;
SAmo *BROWNING_Amo	= NULL;
SAmo *AK47_Amo		= NULL;
SAmo *GRENADE_Amo	= NULL;

Model *chaise1	= NULL;
Model *monstre1	= NULL; 
Model *table1	= NULL;
Model *gun1	= NULL; 
Model *lampe1	= NULL;
Model *grenade1	= NULL;
Md2Model* mod_md2 	= NULL;

TextureGL* tex_pt 	= NULL;
TextureGL* tex_name	= NULL;
TextureGL* tex_port	= NULL;
TextureGL* tex_gril	= NULL;
TextureGL* tex_sol	= NULL;
TextureGL* tex_plafon	= NULL;


void colorisationMonstre(SEntity* monstre)
{
	Color Blanc(1.,1.,1.), Kaki(0.15, 0.31, 0.15);
	Color Metal(0.55, 0.55, 0.55);
	Color Yeux(0.7, 0.12, 0.10);
	Color Or(0.82, 0.74, 0.29);
	Color Marron(0.55, 0.32, 0.2);
	Color Noir(0.05, 0.05, 0.05), Tuyau(0.85, 0.85, 0.95);
	
	monstre->setDiffuseMaterial(0, Kaki);
	monstre->setDiffuseMaterial(1, Yeux);
	monstre->setDiffuseMaterial(2, Metal);
	monstre->setSpecularMaterial(2, Noir);
	monstre->setDiffuseMaterial(3, Yeux);
	monstre->setDiffuseMaterial(4, Kaki);
	monstre->setDiffuseMaterial(5, Kaki);
	monstre->setDiffuseMaterial(6, Kaki);
	monstre->setDiffuseMaterial(7, Tuyau);
	monstre->setDiffuseMaterial(8, Tuyau);
	monstre->setDiffuseMaterial(9, Metal);
	monstre->setDiffuseMaterial(10, Metal);
	monstre->setDiffuseMaterial(11, Kaki);
	monstre->setDiffuseMaterial(12, Kaki);
	monstre->setDiffuseMaterial(13, Kaki);
	monstre->setDiffuseMaterial(14, Kaki);
	monstre->setDiffuseMaterial(15, Kaki);
	monstre->setDiffuseMaterial(16, Kaki);
	monstre->setDiffuseMaterial(17, Or);
	monstre->setDiffuseMaterial(18, Or);
	monstre->setDiffuseMaterial(19, Kaki);
	monstre->setDiffuseMaterial(20, Tuyau);
	monstre->setDiffuseMaterial(21, Tuyau);
	monstre->setDiffuseMaterial(22, Tuyau);
	monstre->setDiffuseMaterial(23, Marron);
	monstre->setSpecularMaterial(23, Marron);
	monstre->setDiffuseMaterial(24, Kaki);
	monstre->setDiffuseMaterial(25, Metal);
	monstre->setDiffuseMaterial(26, Kaki);
	monstre->setDiffuseMaterial(27, Kaki);
	monstre->setDiffuseMaterial(28, Noir);
	monstre->setDiffuseMaterial(29, Kaki);
	monstre->setDiffuseMaterial(30, Metal);
	monstre->setDiffuseMaterial(31, Metal);
	monstre->setDiffuseMaterial(32, Metal);
	monstre->setDiffuseMaterial(33, Kaki);
	monstre->setDiffuseMaterial(34, Kaki);
	monstre->setDiffuseMaterial(35, Noir);
	monstre->setDiffuseMaterial(36, Metal);
	monstre->setDiffuseMaterial(37, Metal);
	monstre->setDiffuseMaterial(38, Kaki);
	monstre->setDiffuseMaterial(39, Kaki);
	monstre->setDiffuseMaterial(40, Noir);
	monstre->setDiffuseMaterial(41, Metal);
	monstre->setDiffuseMaterial(42, Kaki);
	monstre->setDiffuseMaterial(43, Kaki);
	monstre->setDiffuseMaterial(44, Noir);
	monstre->setDiffuseMaterial(45, Kaki);
	
	monstre->setDiffuseMaterial(46, Kaki);
	monstre->setSpecularMaterial(46, Noir);
	monstre->setDiffuseMaterial(47, Kaki);
	monstre->setSpecularMaterial(47, Noir);
	monstre->setDiffuseMaterial(49, Metal);
	
	for(int i(50);i<=64;i++)
		monstre->setDiffuseMaterial(i, Metal);
	
	monstre->setDiffuseMaterial(65, Metal);
}

void init()
{
	scene_principale = new Scene();
	scene_principale->initGL();
	
	tex_pt=new TextureGL();
	textim_pt = (textureImage *)malloc(sizeof(textureImage));
	loadBMP("./Textures/Particle.bmp", textim_pt);
	
	init_arme();
	init_model();
	init_texture();
	
	
	for(int i(0);i<6;i++)
	{
		for(int j(0);j<8;j++)
		{
			if(!(i == 4 && j == 3) && !(i == 5 && j == 3))
				scene_principale->addObject(new SCaisse(10.5, 10.5, 10., pR3(-20.+j*10.5, 14.5-(i*10.5), -50.), tex_name, vR3(0., 0., 1.)));
			else
				scene_principale->addObject(new SCaisse(10.5, 10.5, 10., pR3(-20.+j*10.5, 14.5-(i*10.5), -50.)));
				
		}
	}
	
	for(int i(0);i<6;i++)
		for(int j(0);j<8;j++)
			scene_principale->addObject(new SCaisse(10.5, 10.5, 10., pR3(-20.+j*10.5, 14.5-(i*10.5), -50.+5.25+8*10.5), tex_name, vR3(0., 0., -1.)));
	
	for(int i(0);i<6;i++)
	{
		for(int j(0);j<8;j++)
		{
			if(!(i == 1 && j == 3))
				scene_principale->addObject(new SCaisse(0.25, 10.5, 10.5, pR3(-20.-5.25, 14.5-(i*10.5), -50.+5.25+j*10.5), tex_name, vR3(1., 0., 0.)));
			else
				scene_principale->addObject(new SCaisse(0.25, 10.5, 10.5, pR3(-20.-5.25, 14.5-(i*10.5), -50.+5.25+j*10.5), tex_gril, vR3(1., 0., 0.)));
		}
	}
	
	float start_y;
		
	for(int i(0);i<6;i++)
	{
		for(int j(0);j<8;j++)
		{
			start_y = 14.5-(i*10.5);
			scene_principale->addObject(new SCaisse(0.25, 10.5, 10.5, pR3(-20.-5.25+8.*10.5, start_y, -50.+5.25+j*10.5), tex_name, vR3(-1., 0., 0.)));
		}
	}
					
	for(int i(0);i<8;i++)
		for(int j(0);j<8;j++)
			scene_principale->addSol(new SCaisse(10.5, 0.25, 10.5, pR3(-20.+j*10.5, start_y-5.25, -50.+5.25+i*10.5), tex_sol, vR3(0., 1., 0.)));
		
	for(int i(0);i<8;i++)
		for(int j(0);j<8;j++)
			scene_principale->addObject(new SCaisse(10.5, 0.25, 10.5, pR3(-20.+j*10.5, 14.5+5.25, -50.+5.25+i*10.5), tex_plafon, vR3(0., -1., 0.)));
			
	Color tab_c[3] 	= { Color(1., 1., 1.), Color(1., 1., 1.), Color(1., 1., 1.) };
	
	scene_principale->addLumiere(new LumiereDir(pR3(), tab_c, vR3(-120, 274.5, -40.25)));
	scene_principale->addLumiere(new LumiereDir(pR3(), tab_c, vR3(20., 0., -5.)));
	
	entite2Add = new SEntity();
	entite2Add->loadFromMyModel(*table1);
	entite2Add->loadTexture(0, "./Textures/table_tex.ppm");
	entite2Add->resize(25.);
	entite2Add->rotateX(-M_PI / 2.);
	entite2Add->rotateY(-M_PI / 2.);	
	entite2Add->setInitPos(pR3(35., start_y, -3.25));
	entite2Add->setDiffuseMaterial(0, Color(1., 1., 1.));
	
	scene_principale->addEntity(entite2Add);
	
	entite2Add = NULL;
	entite2Add = new SEntity();
	entite2Add->loadFromMyModel(*chaise1);
	entite2Add->resize(15.);
	entite2Add->rotateX(-M_PI / 2.);
	entite2Add->rotateY(-M_PI / 2.6);
	entite2Add->setInitPos(pR3(45., start_y, -3.25));
	entite2Add->setDiffuseMaterial(0, Color(0.65, 0.65, 0.65));
	
	scene_principale->addEntity(entite2Add);
	
	entite2Add = NULL;
	entite2Add = new SEntity();
	entite2Add->loadFromMyModel(*lampe1);
	entite2Add->resize(10.);
	entite2Add->rotateX(-M_PI / 2.);
	entite2Add->setInitPos(pR3(20., 14.5, -5.25));
	entite2Add->setDiffuseMaterial(0, Color(1., 1., 0.85));
	entite2Add->setDiffuseMaterial(1, Color(116./255.,108./255., 62./255.));
	
	scene_principale->addEntity(entite2Add);
	
	monstre2Add = NULL;
	monstre2Add = new SMonstre();
	monstre2Add->importMd2(mod_md2, "./anorms.h");
	//monstre2Add->loadNormals("./anomrs.h");
	//monstre2Add->loadFromMyModel(*monstre1);
	/*monstre2Add->resize(15);
	monstre2Add->rotateX(-M_PI / 2.);
	monstre2Add->rotateY(-M_PI / 2.);
	*/
	monstre2Add->setV0(vR3(-5., 0., 0.));
	monstre2Add->setMass(2.);
	monstre2Add->setDensity(0.05);
	//monstre2Add->setLookAt(vR3(-5., 0., 0.));
	
	//scene_principale->addMonstre(monstre2Add);
	
	/* Grenade */
	
	arme2add = NULL;
	arme2add = new SArme(SArme::GRENADE);
	arme2add->loadFromMyModel(*grenade1);
	arme2add->resize(2.5);
	arme2add->rotateX(M_PI);
	arme2add->setInitPos(pR3(10., start_y-3., -3.25));

	arme2add->setV0(vR3(0., 0., 0.));
	arme2add->setMass(2.5);
	arme2add->setDensity(0.8);
	arme2add->setDiffuseMaterial(0, Color(0.80, 0.80, 0.80));
	arme2add->setSpecularMaterial(0, Color(0.0, 0.0, 0.0));
	arme2add->setDiffuseMaterial(1, Color(0.80, 0.80, 0.80));
	arme2add->setSpecularMaterial(1, Color(0.0, 0.0, 0.0));
	arme2add->setDiffuseMaterial(2, Color(0.0, 0.15, 0.0));
	arme2add->setSpecularMaterial(2, Color(0.0, 0.0, 0.0));
	arme2add->setDiffuseMaterial(3, Color(0.80, 0.80, 0.80));
	
	scene_principale->addArme2Pick(arme2add);
	
	/* Fin grenade */
	
	arme2add = NULL;
	arme2add = new SArme(SArme::BROWNING);
	arme2add->loadFromMyModel(*gun1);
	arme2add->resize(1.);
	arme2add->rotateZ(-M_PI);
	arme2add->rotateY(M_PI/2.);
	arme2add->setInitPos(pR3(0., 0., 0.));
	arme2add->setDiffuseMaterial(0, Color(0.35, 0.35, 0.35));
	arme2add->setSpecularMaterial(0, Color(0.08, 0.08, 0.08));
	
	scene_principale->addArme(arme2add);
	
	
	
	/*ent_md2 = new SEntity();
	
	ent_md2->importMd2(mod_md2);
	ent_md2->loadTexture(0, "./Textures/monstre_1.ppm");
	ent_md2->setV0(vR3(0., 0., 0.));
	ent_md2->rotateX(-M_PI/2.);
	ent_md2->setInitPos(pR3(0., -10., 0.));	
	ent_md2->setMass(2.5);
	ent_md2->setDensity(0.8);
	//ent_md2->setDiffuseMaterial(0, Color(0.8, 0., 0.));
	
	
	scene_principale->addEntity(ent_md2);*/
	
	arme2add->setInitPos(pR3(0., 0., 0.));
}

void update()
{
	glutPostRedisplay();
}

static int delay = 0;

void display()
{
	glPushMatrix();
	scene_principale->display();
	//ent_md2->display();
	glPopMatrix();
	
	glutSwapBuffers();
}

void reshape(int w,int h)
{
	glViewport (0, 0, (GLsizei) w, (GLsizei) h);
   	glMatrixMode(GL_PROJECTION);
   	glLoadIdentity();
	gluPerspective(60.0, (GLfloat)w / (GLfloat)h, 1., 1000.0);
   	glMatrixMode(GL_MODELVIEW);
   	glLoadIdentity();
}

void mouse(int button, int state, int x, int y)
{
  	scene_principale->mouseMoveManager(button, state, x, y);
}

		
void mouse_motion(int x, int y)
{
	scene_principale->mouseManager(x, y);
}

void keyboard(unsigned char key, int x, int y)
{
	scene_principale->keyManager(key, x, y, grenade1);
}





int main(int argc, char **argv)
{
	pthread_t *t=new pthread_t();
	void* list=NULL;
	int ret=0;
	if ( (ret= pthread_create(t,NULL,Client_Reseau,(void*)&list ))!=0)
			cout<<"err create_thread"<<endl;
	
	if( !alutInit (&argc, argv))
	{
		cout<<"alutInit err :"<<alutGetErrorString (alutGetError())<<endl;
	}
	
	//cout<<"	type= " <<alutGetMIMETypes (ALUT_LOADER_BUFFER)<<endl;
	
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutInitWindowSize(800, 600);
	glutInitWindowPosition(10,10);
	glutCreateWindow("FPS version 1.3");
	init();
	
	glutDisplayFunc(display); 
   	glutReshapeFunc(reshape);
	glutKeyboardFunc(keyboard);
	glutMouseFunc(mouse);
	glutMotionFunc(mouse_motion);
   	glutMainLoop();
	
	
   	
	return EXIT_SUCCESS;
}
