// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */


#include <vector>


#include <motor/model.hh>


Model::Model(const char* fic):allObjM()
{
	USHORT id, l_qty(0);
	UINT leng;
	UCHAR l_char;
	float pTmp1,pTmp2, pTmp3;
	USHORT  valT, valT1, valT2, valT3;
	ifstream flit(fic, ios::binary | ios::in);
	
	SPerso* new_obj = NULL;
	
	bool passe(false);
	vector<Color> lColor;
	
	while(!flit.eof())
	{
		l_char = 'n';
				
		flit.read((char*)&id, sizeof(USHORT));
		flit.read((char*)&leng, sizeof(UINT));

		UINT ind(0);
		Color amb(-1., -1., -1.), dif(-1., -1., -1.), spe(-1., -1., -1.);
		
		switch(id)
		{
			/*case 0xAFFF: readMaterials(flit,leng, lColor); 
			break;*/
			case 0x4000:
				for(int i(0);i<20 && l_char != '\0';i++)
					flit.read((char*)&l_char, sizeof(UCHAR));break;
				
			case 0x4110: 	passe = true; new_obj = new SPerso;
					flit.read((char*)&l_qty, sizeof(USHORT));

					for(USHORT s(0);s<l_qty;s++)
					{
						flit.read((char*)&(pTmp1), sizeof(float));
						flit.read((char*)&(pTmp2), sizeof(float));
						flit.read((char*)&(pTmp3), sizeof(float));

						new_obj->sVList.push_back(SPoint(pTmp1, pTmp2, pTmp3));
					}

					break;
				
			case 0x4120: 		
						flit.read((char*)&l_qty, sizeof(USHORT));

						for(USHORT s(0);s<l_qty;s++, ind+=3)
						{
							flit.read((char*)&valT1, sizeof(USHORT));
							flit.read((char*)&valT2, sizeof(USHORT));
							flit.read((char*)&valT3, sizeof(USHORT));
							flit.read((char*)&valT, sizeof(USHORT));
							
							new_obj->sFList.push_back(Face(valT1, valT2, valT3));
						} 

						break;
			
			case 0x4d4d: break;
			case 0x3d3d: break;
			case 0x4140: 	 	flit.read((char*)&l_qty, sizeof(USHORT));
						
						for(USHORT s(0);s<l_qty;s++, ind+=2)
						{
							flit.read((char*)(&pTmp1), sizeof(float)); 
							flit.read((char*)(&pTmp2), sizeof(float));
							new_obj->sTList.push_back(-pTmp1);
							new_obj->sTList.push_back(-pTmp2);
						}
						break;
			case 0x4100: break;
			
			default: flit.seekg(leng-6, ios::cur); break;
		}
		
		if(passe)
		{
			allObjM.push_back(new_obj);
			passe = false;
		}
	}

	flit.close();
}


Model::~Model()
{
	for(list<SPerso*>::iterator it=allObjM.begin();it!=allObjM.end();it++)
		delete (*it);
	allObjM.clear();	
}
