// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */


/*#include <stdio.h>*/
#include <stdlib.h>
#include <unistd.h>
#include <iostream>
#include <list>


#include <network/paquet.hh>
//#include <network/serveur2/serveur.h>

using namespace std;

Paquet::Paquet(Serveur* serv,float _id):ID(_id)
{ srv=serv;}
 
/* 
Paquet::Paquet(float _id):ID(_id)
{}
*/

Paquet:: ~Paquet()
{}

bool Paquet::receive(int sock)
{
	cout<<"Paquet::RECEIVE"<<endl;

       PAQUET_TYPE type;                           
       read(sock,&type,sizeof(PAQUET_TYPE));
       
       float tmp;
    //   int _soc;
       list<float> tmp_ID=srv->getAllID();
       switch(type)
      {                      
            case MOVE:
	    	   cout<<"\tMOVE receive"<<endl;   
		   float tmp_data[7];
	           read(sock,&tmp_data, sizeof(float)*7 );
		   
                   for(list<float>::const_iterator it=tmp_ID.begin();it!=tmp_ID.end();it++)                            
        	             if( (*it) != ID ) send( (*it) ,MOVE,tmp_data);
	           break;
      
            case KILLED: // envoye par le client qui meurt et retransmi direct
                   cout<<"\tKILLED receive"<<endl;
		   read(sock,&tmp, sizeof(float) );
                   srv->del(ID);
		   return false;
                   break;                //1 float pour l id du mort
            
            case FIRE: break;
	    
            case CONNECT_ASK:
       		cout<<"\tCONNECT_ASK"<<endl;
                srv->add(ID,sock);
		send(ID,CONNECT_YES,&ID);
		float test[7];
		for(list<float>::const_iterator it=tmp_ID.begin();it!=tmp_ID.end();it++)                            
        	             if( (*it) != ID )   send((*it),NEW_PERSO,test);

                 break;
		
		case DISCONNECT:
			break;
			 
            case NEW_PERSO:    
            case TOUCHED:
	    default: break; // Mais que se passe-t-il ???                           
      }
      return true;
 }


bool Paquet::send(float _id,PAQUET_TYPE type,float* data)
{
	cout<<"Paquet::SEND"<<endl;
	int tmp_socket( srv->getSocket(_id) );
	if( tmp_socket == -1 ) return false;  //Aucun client avec _id trouv
	
	pthread_mutex_t *tmp_mutex=srv->getMutex(_id);

	pthread_mutex_lock( tmp_mutex );
	write( tmp_socket ,&type,sizeof(PAQUET_TYPE));
	pthread_mutex_unlock(tmp_mutex );

	switch(type)
	{			   
		case MOVE: 
			pthread_mutex_lock( tmp_mutex );	 
			write( tmp_socket,data, (sizeof(float)*7) );
			pthread_mutex_unlock( tmp_mutex );
			break;
       
		case KILLED: 
			cout<<"\tKILLED send"<<endl;
			pthread_mutex_lock( tmp_mutex );
			write(tmp_socket,data,sizeof(float));
			pthread_mutex_unlock(tmp_mutex );
			break;  	      //1 float pour l id du mort

		case TOUCHED: break;
 
		case NEW_PERSO:
			cout<<"\tNEW_PERSO send"<<endl;
			pthread_mutex_lock( tmp_mutex );
			write(tmp_socket,data, (sizeof(float)*7) );
			pthread_mutex_unlock(tmp_mutex );
			break;
	      
		case CONNECT_NO:
			cout<<"\tCONNECT_NO send"<<endl;
			pthread_mutex_lock( tmp_mutex );
			write(tmp_socket,data, sizeof(float) );
			pthread_mutex_unlock(tmp_mutex );		
			break;

		case CONNECT_YES:
			cout<<"\tCONNECT_YES send"<<endl;
			pthread_mutex_lock( tmp_mutex );
			write(tmp_socket,data, sizeof(float) );
			pthread_mutex_unlock(tmp_mutex );		
			break;
 
		case CONNECT_ASK:
		case FIRE:	     
		default: break; 		
	}
	return true;    
}

