// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */


#include <network/paquet_serv.hh>
#include <network/serveur.hh>


Paquet::Paquet(Serveur* serv,float _id):ID(_id)
{	srv=serv;	}
 
Paquet:: ~Paquet()
{	srv=NULL;	}

bool Paquet::receive(int sock)
{
	float tmp;
	PAQUET_TYPE type;			     
	cout<<"Paquet::RECEIVE"<<endl;
	float tmp_data[7];
	
	read(sock,&type,sizeof(PAQUET_TYPE));
	cout<<"apre read"<<endl;
 	list<float> tmp_ID=srv->getAllID();
	
	switch(type)
	{		       
		case MOVE:
			cout<<"\tMOVE receive"<<endl;	
			read(sock,&tmp_data, sizeof(float)*7 );
			for(list<float>::const_iterator it=tmp_ID.begin();it!=tmp_ID.end();it++)			    
				if( (*it) != ID )
					send( (*it) ,MOVE,tmp_data);
		break;

		case KILLED: // envoye par le client qui meurt et retransmi direct
			cout<<"\tKILLED receive"<<endl;
			read(sock,&tmp, sizeof(float) );
			for(list<float>::const_iterator it=tmp_ID.begin();it!=tmp_ID.end();it++)			    
				if( (*it) != ID )
					send( (*it),KILLED,&ID);
			srv->del(ID);
			return false;
		break;  	      //1 float pour l id du mort

		case CONNECT_ASK:
			cout<<"\tCONNECT_ASK"<<endl;
			srv->add(ID,sock);
			send(ID,CONNECT_YES,&ID);
			for(list<float>::const_iterator it=tmp_ID.begin();it!=tmp_ID.end();it++)			    
				if( (*it) != ID )
					send((*it),NEW_PERSO,tmp_data);
		break;

		case FIRE: break;
		
		case DISCONNECT:break;
     
		case NEW_PERSO:    
		case TOUCHED:
		default: break; // Mais que se passe-t-il ???				
	}
	return true;
}


bool Paquet::send(float _id,PAQUET_TYPE type,float* data)// on envoie au client _id
{
	cout<<"Paquet::SEND"<<endl;
	int tmp_socket( srv->getSocket(_id) );
	if( tmp_socket == -1 ) return false;  //Aucun client avec _id trouv
	
	pthread_mutex_t *tmp_mutex=srv->getMutex(_id);
	if( tmp_mutex == NULL ) return false;  //On a pas le mutex
	
	pthread_mutex_lock( tmp_mutex );
	write( tmp_socket ,&type,sizeof(PAQUET_TYPE));
	pthread_mutex_unlock(tmp_mutex );

	switch(type)
	{			   
		case MOVE: 
			cout<<"\tMOVE send"<<endl;
			pthread_mutex_lock( tmp_mutex );	 
			write( tmp_socket,data, (sizeof(float)*7) );
			pthread_mutex_unlock( tmp_mutex );
			break;
       
		case KILLED: 
			cout<<"\tKILLED send"<<endl;
			pthread_mutex_lock( tmp_mutex );
			write(tmp_socket,data,sizeof(float));
			pthread_mutex_unlock(tmp_mutex );
			break;  	      //1 float pour l id du mort

		case TOUCHED: break;
 
		case NEW_PERSO:
			cout<<"\tNEW_PERSO send"<<endl;
			pthread_mutex_lock( tmp_mutex );
			write(tmp_socket,data, (sizeof(float)*7) );
			pthread_mutex_unlock(tmp_mutex );
			break;
	      
		case CONNECT_NO:
			cout<<"\tCONNECT_NO send"<<endl;
			pthread_mutex_lock( tmp_mutex );
			write(tmp_socket,data, sizeof(float) );
			pthread_mutex_unlock(tmp_mutex );		
			break;

		case CONNECT_YES:
			cout<<"\tCONNECT_YES send"<<endl;
			pthread_mutex_lock( tmp_mutex );
			write(tmp_socket,data, sizeof(float) );
			pthread_mutex_unlock(tmp_mutex );		
			break;
 
		case CONNECT_ASK:
		case FIRE:	     
		default: break; 		
	}
	return true;    
}

