// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */


#include <vector>
#include <stdlib.h>
#include <algorithm>
#include <GL/glut.h>

#include <loader.hh>
#include <motor/real_obj.hh>
#include <motor/model.hh>



/* --- Mthode classe Caisse --- */

SCaisse::SCaisse() : SBox()
{
	tex = NULL;
}

SCaisse::SCaisse(double _l, double _h, double _w, const pR3& _p, TextureGL* tex_name, const vR3& _v) : SBox(_l, _h, _w, Color(0., 0., 0.), _p), normale(_v)
{	tex = tex_name; }



SCaisse::SCaisse(const SCaisse& _ca) : SBox((SBox)_ca), normale()
{
	tex = NULL;
}

SCaisse::~SCaisse()
{
/*	if(tex)
		delete tex;
	*/
	tex = NULL;
}

SCaisse& SCaisse::operator =(const SCaisse& _ca)
{
	sLong   = _ca.sLong;
	sHeight = _ca.sHeight;
	sWidth  = _ca.sWidth;
	normale = _ca.normale;
	
	if(_ca.tex)
		tex = _ca.tex;
	
	return *this;
}

bool SCaisse::loadTexture(TextureGL* tex_new)
{
		tex = tex_new;
		return true;
}

void SCaisse::display() const
{
	static Material matiere;
	
	GLdouble tab_norm[3] = { normale.x, normale.y, normale.z };
	
	matiere.setDiffuse(Color(1., 1., 1.));
	matiere.setSpecular(Color(1., 1., 1.));
	
	if(tex)
	{
		matiere.enable();
		tex->activer();
	}
			
	vector<SPoint> som;
	for(list<SPoint>::const_iterator it = sVList.begin();it != sVList.end();it++)
		som.push_back(*it);			
	
	glBegin(GL_QUADS);
		glNormal3dv(tab_norm);glTexCoord2f(0., 0.); glVertex3f(som[0].getMassCenter().x, som[0].getMassCenter().y, som[0].getMassCenter().z);
		glNormal3dv(tab_norm);glTexCoord2f(0., 1.); glVertex3f(som[1].getMassCenter().x, som[1].getMassCenter().y, som[1].getMassCenter().z);
		glNormal3dv(tab_norm);glTexCoord2f(1., 1.); glVertex3f(som[2].getMassCenter().x, som[2].getMassCenter().y, som[2].getMassCenter().z);
		glNormal3dv(tab_norm);glTexCoord2f(1., 0.); glVertex3f(som[3].getMassCenter().x, som[3].getMassCenter().y, som[3].getMassCenter().z);	
		
		glNormal3dv(tab_norm);glTexCoord2f(0., 0.); glVertex3f(som[0].getMassCenter().x, som[0].getMassCenter().y, som[0].getMassCenter().z);
		glNormal3dv(tab_norm);glTexCoord2f(0., 1.); glVertex3f(som[1].getMassCenter().x, som[1].getMassCenter().y, som[1].getMassCenter().z);
		glNormal3dv(tab_norm);glTexCoord2f(1., 1.); glVertex3f(som[4].getMassCenter().x, som[4].getMassCenter().y, som[4].getMassCenter().z);
		glNormal3dv(tab_norm);glTexCoord2f(1., 0.); glVertex3f(som[5].getMassCenter().x, som[5].getMassCenter().y, som[5].getMassCenter().z);	
		
		glNormal3dv(tab_norm);glTexCoord2f(1., 1.); glVertex3f(som[4].getMassCenter().x, som[4].getMassCenter().y, som[4].getMassCenter().z);
		glNormal3dv(tab_norm);glTexCoord2f(1., 0.); glVertex3f(som[5].getMassCenter().x, som[5].getMassCenter().y, som[5].getMassCenter().z);	
		glNormal3dv(tab_norm);glTexCoord2f(0., 0.); glVertex3f(som[7].getMassCenter().x, som[7].getMassCenter().y, som[7].getMassCenter().z);
		glNormal3dv(tab_norm);glTexCoord2f(0., 1.); glVertex3f(som[6].getMassCenter().x, som[6].getMassCenter().y, som[6].getMassCenter().z);
				
		glNormal3dv(tab_norm);glTexCoord2f(0., 0.); glVertex3f(som[1].getMassCenter().x, som[1].getMassCenter().y, som[1].getMassCenter().z);
		glNormal3dv(tab_norm);glTexCoord2f(0., 1.); glVertex3f(som[2].getMassCenter().x, som[2].getMassCenter().y, som[2].getMassCenter().z);		
		glNormal3dv(tab_norm);glTexCoord2f(1., 1.); glVertex3f(som[6].getMassCenter().x, som[6].getMassCenter().y, som[6].getMassCenter().z);	
		glNormal3dv(tab_norm);glTexCoord2f(1., 0.); glVertex3f(som[4].getMassCenter().x, som[4].getMassCenter().y, som[4].getMassCenter().z);
		
		glNormal3dv(tab_norm);glTexCoord2f(0., 0.); glVertex3f(som[2].getMassCenter().x, som[2].getMassCenter().y, som[2].getMassCenter().z);
		glNormal3dv(tab_norm);glTexCoord2f(0., 1.); glVertex3f(som[3].getMassCenter().x, som[3].getMassCenter().y, som[3].getMassCenter().z);		
		glNormal3dv(tab_norm);glTexCoord2f(1., 1.); glVertex3f(som[7].getMassCenter().x, som[7].getMassCenter().y, som[7].getMassCenter().z);	
		glNormal3dv(tab_norm);glTexCoord2f(1., 0.); glVertex3f(som[6].getMassCenter().x, som[6].getMassCenter().y, som[6].getMassCenter().z);
		
		glNormal3dv(tab_norm);glTexCoord2f(0., 0.); glVertex3f(som[0].getMassCenter().x, som[0].getMassCenter().y, som[0].getMassCenter().z);
		glNormal3dv(tab_norm);glTexCoord2f(0., 1.); glVertex3f(som[3].getMassCenter().x, som[3].getMassCenter().y, som[3].getMassCenter().z);
		glNormal3dv(tab_norm);glTexCoord2f(1., 1.); glVertex3f(som[7].getMassCenter().x, som[7].getMassCenter().y, som[7].getMassCenter().z);
		glNormal3dv(tab_norm);glTexCoord2f(1., 0.); glVertex3f(som[5].getMassCenter().x, som[5].getMassCenter().y, som[5].getMassCenter().z);
	glEnd();
		
	if(tex)
		tex->desactiver();
}


///////////////////////////////////////////////// SMur Class ////////////////////////////////////////

SMur::SMur() : SPlan(), matiere()
{
	tex = NULL;
}

SMur::SMur(const SMur& _src) : SPlan((SPlan)_src), matiere()
{
	tex = NULL;
	
	gp_pt[0] = _src.gp_pt[0];
	gp_pt[1] = _src.gp_pt[1];
	gp_pt[2] = _src.gp_pt[2];
}

SMur& SMur::operator =(const SMur& _src)
{
	tex = NULL;
	
	(*this).operator =(_src);
	
	gp_pt[0] = _src.gp_pt[0];
	gp_pt[1] = _src.gp_pt[1];
	gp_pt[2] = _src.gp_pt[2];
	
	matiere = _src.matiere;
	
	return (*this);
}

SMur::SMur(const vR3& _normal, const double& _constant) : SPlan(_normal, _constant), matiere()
{
	tex = NULL;
}

SMur::SMur(const vR3& _normal, const pR3& _point) : SPlan(_point), matiere()
{
	tex = NULL;
}

SMur::SMur(const pR3& _point0, const pR3& _point1, const pR3& _point2) : SPlan(_point0, _point1, _point2), matiere()
{
	tex = NULL;
}

SMur::SMur(const pR3& _point0, const pR3& _point1, const pR3& _point2, const pR3& _point3) : SPlan(_point0, _point1, _point2), matiere()
{
	tex = NULL;
	
	gp_pt[0] = _point0;
	gp_pt[1] = _point1;
	gp_pt[2] = _point2;
	gp_pt[3] = _point3;
}

SMur::~SMur()
{
	if(tex)
		delete tex;
	tex = NULL;
}
		
bool SMur::loadTexture(const char* fic)
{
	if(tex)
		delete tex;
	tex = NULL;
	
	if(fic)
	{
		tex = new TextureGL(fic);
		return true;
	}
	
	return false;
}

void SMur::display() const
{
	if(tex)
		tex->activer();
	
	matiere.enable();
	
	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	
	glBegin(GL_QUADS);
		glTexCoord2f(0., 0.); glVertex3f(gp_pt[0].x, gp_pt[0].y, gp_pt[0].z);
		glTexCoord2f(0., 1.); glVertex3f(gp_pt[1].x, gp_pt[1].y, gp_pt[1].z);
		glTexCoord2f(1., 1.); glVertex3f(gp_pt[2].x, gp_pt[2].y, gp_pt[2].z);
		glTexCoord2f(1., 0.); glVertex3f(gp_pt[3].x, gp_pt[3].y, gp_pt[3].z);
	glEnd();	
	
	if(tex)
		tex->desactiver();
	
	glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
}


///////////////////////////////////////////// PERSONNAGE ///////////////////////////////////////////////


SPerso::SPerso(const double& _mass, const pR3& _mCenter, const vR3& _v0, const double& _density) 
		: SPolyhedron(_mass, _mCenter, _v0, _density), nbpt(0), nbfc(0), matiere()
{
	tab_vx 		= NULL;
	tab_fc 		= NULL;
	tab_tx 		= NULL;
	tab_norm 	= NULL;
	tex    		= NULL;
	boundBox 	= NULL;
}

SPerso::SPerso(const SPerso& src) : SPolyhedron((SPolyhedron)src), nbpt(src.nbpt), nbfc(src.nbfc), matiere(src.matiere)
{
	tab_vx = new GLfloat[nbpt*3];
	tab_fc = new GLint[nbfc];
	tab_tx = new GLfloat[nbpt*2];
	tab_norm = new GLfloat[nbpt*3];
	
	tex = NULL;
			
	if(src.tex)
		tex = new TextureGL(*(src.tex));
	
	boundBox = NULL;
	
	if(src.boundBox)
		boundBox = new SBox(*(src.boundBox));
	
	memcpy(tab_vx, src.tab_vx, sizeof(GLfloat)*3*nbpt);
	memcpy(tab_fc, src.tab_fc, sizeof(GLint)*3*nbfc);
	memcpy(tab_tx, src.tab_tx, sizeof(GLfloat)*2*nbpt);
	memcpy(tab_norm, src.tab_norm, sizeof(GLfloat)*3*nbpt);
}

SPerso& SPerso::operator =(const SPerso& src)
{
	(*this).SPolyhedron::operator =((SPolyhedron)src);
	nbpt = src.nbpt;
	nbfc = src.nbfc;
	matiere = src.matiere;
	
	if(tab_vx)
	{
		delete[] tab_vx;
		tab_vx = new GLfloat[nbpt*3];
		memcpy(tab_vx, src.tab_vx, sizeof(GLfloat)*3*nbpt);
	}
	if(tab_fc)
	{
		delete[] tab_fc;
		tab_fc = new GLint[nbfc];
		memcpy(tab_fc, src.tab_fc, sizeof(GLint)*3*nbfc);
	}
	if(tab_tx)
	{
		delete[] tab_tx;
		tab_tx = new GLfloat[nbpt*2];
		memcpy(tab_tx, src.tab_tx, sizeof(GLfloat)*2*nbpt);
	}
	if(tab_norm)
	{
		delete[] tab_norm;
		tab_norm = new GLfloat[nbpt*3];
		memcpy(tab_norm, src.tab_norm, sizeof(GLfloat)*3*nbpt);
	}
	if(boundBox)
	{
		delete boundBox;
	}
	if(tex)
		delete tex;
	
	tex = NULL;
	
	if(src.tex)
		tex = new TextureGL(*(src.tex));
	
	boundBox = NULL;
	
	if(src.boundBox)
		boundBox = new SBox(*(src.boundBox));

	return *this;
}

SPerso::~SPerso()
{
	if(tex)
		delete tex;
	if(tab_vx)
		delete[] tab_vx;
	if(tab_fc)
		delete[] tab_fc;
	if(tab_tx)
		delete[] tab_tx;
	if(tab_norm)
		delete[] tab_norm;
	if(boundBox)
		delete boundBox;
	
	tab_vx = tab_tx = tab_norm = NULL;
	tab_fc = NULL;
	tex = NULL;
}
		
bool SPerso::loadTexture(const char* fic)
{
	if(tex)
		delete tex;
	tex = NULL;
	
	if(fic)
	{
		cout << "1er passage: " << tab_tx[0] << ", " << tab_tx[1] << endl;
		tex = new TextureGL(fic);
		return true;
	}
	
	return false;
}

bool SPerso::loadModel(GLfloat& minx, GLfloat& miny, GLfloat& minz, GLfloat& maxx, GLfloat& maxy, GLfloat& maxz)
{
	unsigned i(0);
	
	nbpt = sVList.size();
	
	if(tab_vx)
		delete[] tab_vx;

	tab_vx = new GLfloat[3*nbpt];
	
	
	for(list<SPoint>::iterator it = sVList.begin();it != sVList.end();it++, i+=3)
	{
		*(tab_vx+i) = (GLfloat)((*it).getMassCenter().x);
		*(tab_vx+i+1) = (GLfloat)((*it).getMassCenter().y);
		*(tab_vx+i+2) = (GLfloat)((*it).getMassCenter().z);
		
		if(*(tab_vx+i) > maxx)
			maxx = *(tab_vx+i);
		if(*(tab_vx+i) < minx)
			minx = *(tab_vx+i);
		
		if(*(tab_vx+i+1) > maxy)
			maxy = *(tab_vx+i+1);
		if(*(tab_vx+i+1) < miny)
			miny = *(tab_vx+i+1);
		
		if(*(tab_vx+i+2) > maxz)	
			maxz = *(tab_vx+i+2);
		if(*(tab_vx+i+2) < minz)
			minz = *(tab_vx+i+2);
	}
	
	alloc(sFList.size()*3);
	
	i = 0;
	
	for(list<Face>::iterator itfc = sFList.begin();itfc != sFList.end();itfc++, i+=3)
	{
		*(tab_fc+i) = ((*itfc).index[0]);
		*(tab_fc+i+1) = ((*itfc).index[1]);
		*(tab_fc+i+2) = ((*itfc).index[2]);
	}
	
	i = 0;
	tab_tx = new GLfloat[sTList.size()];
	
	for(list<float>::iterator itft = sTList.begin();itft != sTList.end();itft++, i++)
		*(tab_tx+i) = (*itft);

	pR3 pt1(minx, maxy, maxz), pt2(minx, maxy, minz);
	pR3 pt3(maxx, maxy, maxz), 
	    pt4(minx, miny, maxz);
	
	double d1(sqrt(!vR3(pt1, pt2)));
	double d2(sqrt(!vR3(pt3, pt1)));
	double d3(sqrt(!vR3(pt4, pt1)));
	
	if(boundBox)
		delete boundBox;
	
	mass_center = pR3((maxx+minx)/2., (maxy+miny)/2., (maxz+minz)/2. );
	boundBox = new SBox(d2, d3, d1, Color(1., 0., 0.), mass_center );
	
	sVList.clear();
	sFList.clear();
	sTList.clear();
	
	calculNorm();
}

void SPerso::display() const
{	
	glVertexPointer(3, GL_FLOAT, 0, tab_vx);
	glNormalPointer(GL_FLOAT, 0, tab_norm);
	
	matiere.enable();

	if(tex && tab_tx)
	{
		glEnable(GL_TEXTURE_2D);
		glEnableClientState(GL_TEXTURE_COORD_ARRAY);
		glTexCoordPointer( 2, GL_FLOAT, 0, tab_tx);
		tex->activer();
	}
	
	glDrawElements( GL_TRIANGLES, nbfc, GL_UNSIGNED_INT, tab_fc );
	
	if(tex && tab_tx)
	{
		glDisable(GL_TEXTURE_2D);
		glDisableClientState(GL_TEXTURE_COORD_ARRAY);
		tex->desactiver();
	}
}


void SPerso::calculNorm()
{
	vR3 vect, norm1, norm2, norm;
	
	if(tab_norm)
		delete[] tab_norm;

	tab_norm = new GLfloat[nbpt*3];
	
	for(int i(0);i<nbpt*3;i++)
		tab_norm[i] = 0;
	
	int moy[nbpt];
	
	for(int i(nbpt);i--;)
		*(moy + i - 1) = 0;

	for(int i(0);i<nbfc;i+=3)
	{
		norm1 = vR3(pR3(tab_vx[tab_fc[i+1]*3], tab_vx[tab_fc[i+1]*3+1], tab_vx[tab_fc[i+1]*3+2]), pR3(tab_vx[tab_fc[i]*3], tab_vx[tab_fc[i]*3+1], tab_vx[tab_fc[i]*3+2]));
		norm2 = vR3(pR3(tab_vx[tab_fc[i+2]*3], tab_vx[tab_fc[i+2]*3+1], tab_vx[tab_fc[i+2]*3+2]), pR3(tab_vx[tab_fc[i]*3], tab_vx[tab_fc[i]*3+1], tab_vx[tab_fc[i]*3+2]));
		norm = norm1 ^ norm2;
		norm.Normalize();

		*(tab_norm+(*(tab_fc+i))*3)   += norm.x;
		*(tab_norm+(*(tab_fc+i))*3+1) += norm.y;
		*(tab_norm+(*(tab_fc+i))*3+2) += norm.z;

		*(tab_norm+(*(tab_fc+i+1))*3)   += norm.x;
		*(tab_norm+(*(tab_fc+i+1))*3+1) += norm.y;
		*(tab_norm+(*(tab_fc+i+1))*3+2) += norm.z;

		*(tab_norm+(*(tab_fc+i+2))*3)   += norm.x;
		*(tab_norm+(*(tab_fc+i+2))*3+1) += norm.y;
		*(tab_norm+(*(tab_fc+i+2))*3+2) += norm.z;

		(*(moy+(*(tab_fc+i))))++;
		(*(moy+(*(tab_fc+i+1))))++;
		(*(moy+(*(tab_fc+i+2))))++;	
	}

	for( int i(0); i < nbpt; i++)
	{
		norm = vR3(*(tab_norm+i*3), *(tab_norm+i*3+1), *(tab_norm+i*3+2));
		norm.Normalize();
		norm = norm / ((double)*(moy+i));
		
		norm.Normalize();
		
		*(tab_norm+i*3) = norm.x;
		*(tab_norm+i*3+1) = norm.y;
		*(tab_norm+i*3+2) = norm.z;
	}	
}



void SPerso::resize(float coef)
{
	assert(boundBox);

	Transform mat_trans(coef, 0.,  0.,
		      0.,  coef, 0.,
		      0.,  0., coef,
		      0., 0., 0.);
	pR3 tmp;
	
	for(int i(0);i<nbpt*3;i+=3)
	{
		tmp = pR3(*(tab_vx+i), *(tab_vx+i+1), *(tab_vx+i+2));
		tmp = mat_trans * tmp;
		*(tab_vx+i) = tmp.x;
		*(tab_vx+i+1) = tmp.y;
		*(tab_vx+i+2) = tmp.z;
	}
	
	for(int i(0);i<nbpt*3;i+=3)
	{
		tmp = pR3(*(tab_norm+i), *(tab_norm+i+1), *(tab_norm+i+2));
		tmp = mat_trans * tmp;
		*(tab_norm+i)   = tmp.x;
		*(tab_norm+i+1) = tmp.y;
		*(tab_norm+i+2) = tmp.z;
		
	}
	
	mass_center = mat_trans * mass_center;
	
	double last_l(boundBox->getLong() * coef), last_h(boundBox->getHeight() * coef), last_w(boundBox->getWidth() * coef);
	
	if(boundBox)
		delete boundBox;
	boundBox = new SBox(last_l, last_h, last_w, Color(), mass_center);
}

void SPerso::rotateX(const double& ang)
{
	assert(boundBox);
	
	Transform mat_trans( 1., 0., 0.,
			     0., cos(ang), sin(ang),
			     0., -sin(ang), cos(ang),
			     0., 0., 0. );
	applyTransform(mat_trans);
	boundBox->applyTransform(mat_trans);
}

void SPerso::rotateY(const double& ang)
{
	assert(boundBox); 			// A virer dans pas longtemps ==> assert() appel a une fonction (ralentissement)	
	
	Transform mat_trans( cos(ang), 0., -sin(ang),
			     0., 1., 0.,
			     sin(ang), 0., cos(ang),
			     0., 0., 0.);
	
	applyTransform(mat_trans);
	boundBox->applyTransform(mat_trans);
}

void SPerso::rotateZ(const double& ang)
{
	assert(boundBox);			// A virer dans pas longtemps ==> assert() appel a une fonction (ralentissement)
	
	Transform mat_trans(cos(ang), sin(ang), 0., 
		      	    -sin(ang), cos(ang), 0., 
		      	    0., 0., 1.,
		      	    0., 0., 0.);
	
	applyTransform(mat_trans);
	boundBox->applyTransform(mat_trans);
}

void SPerso::applyTransform(const Transform& mat_trans, bool maj_norm)
{
	assert(boundBox);			// A virer dans pas longtemps ==> assert() appel a une fonction (ralentissement)
	
	pR3 tmp;
	
	mass_center = (mat_trans * pR3(mass_center));
	boundBox->applyTransform(mat_trans);
	
	for(int i(0);i<nbpt*3;i+=3)
	{
		tmp = pR3(*(tab_vx+i), *(tab_vx+i+1), *(tab_vx+i+2));
		tmp = mat_trans * tmp;
		*(tab_vx+i)   = tmp.x;
		*(tab_vx+i+1) = tmp.y;
		*(tab_vx+i+2) = tmp.z;
	}
	
	if(maj_norm)
		calculNorm();	
}

void SPerso::setInitPos(const pR3& p)
{
	pR3 dpl(mass_center - p);
	
	for(unsigned i(0);i<nbpt*3;i+=3)
	{
		*(tab_vx + i)     = *(tab_vx + i) - dpl.x;
		*(tab_vx + i + 1) = *(tab_vx + i + 1) - dpl.y;
		*(tab_vx + i + 2) = *(tab_vx + i + 2) - dpl.z;
	}
	
	SPerso::updatePosition(p);
}



///////////////////////////////////////////////// CLASSE ENTITE ///////////////////////////////////////////////
//// Attention !!! On doit connaitre la structuration des multi-objets (jambe, bras ...) pour l'animation /////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////


SEntity::SEntity() : SObject(), lookAt(0., 0., 0.),allObj()
{
	boundBox = NULL;
}

SEntity::SEntity(Model& m) : SObject(), lookAt(0., 0., 0.),allObj()
{
	boundBox = NULL;
	loadFromMyModel(m);
	
}


SEntity::SEntity(const SEntity& src) : allObj() 
{
	SPerso* obj = NULL;
	
	lookAt = vR3(src.lookAt);
	
	for(list<SPerso*>::const_iterator it=src.allObj.begin();it!=src.allObj.end();it++)
		allObj.push_back( new SPerso(**it) );

	boundBox = NULL;
	
	if(src.boundBox)
		boundBox = new SBox(*(src.boundBox));
}

SEntity::~SEntity()
{
	if(boundBox)
		delete boundBox;
		
	boundBox = NULL;

	for(list<SPerso*>::iterator it=allObj.begin();it!=allObj.end();it++)
		delete (*it);
	
	allObj.clear();
}


/*
bool SEntity::loadModel(const char* ply)
{
	GLfloat minx(1000000.), miny(1000000.), minz(1000000.), maxx(-1000000.), maxy(-1000000.), maxz(-1000000.);
	GLfloat minxp(1000000.), minyp(1000000.), minzp(1000000.), maxxp(-1000000.), maxyp(-1000000.), maxzp(-1000000.);
	
	SEntity* brrr = this;
	
	loaderMAX lPly(&brrr);
	lPly.load(ply);
	
	for(list<SPerso*>::iterator it=allObj->begin();it!=allObj->end();it++)
	{
		(*it)->loadModel(minxp, minyp, minzp, maxxp, maxyp, maxzp);
		
		if(minxp < minx)
			minx = minxp;
		if(minyp < miny)
			miny = minyp;
		if(minzp < minz)
			minz = minzp;
		
		if(maxxp > maxx)
			maxx = maxxp;
		if(maxyp > maxy)
			maxy = maxyp;
		if(maxzp > minz)
			maxz = maxzp;
		
		minxp = minyp = minzp = 10000000.;
		maxxp = maxyp = maxzp = -10000000.;
	}
					
	pR3 pt1(minx, maxy, maxz), pt2(minx, maxy, minz),
	    pt3(maxx, maxy, maxz), 
	    pt4(minx, miny, maxz);
	
	double d1(sqrt(!vR3(pt1, pt2)));
	double d2(sqrt(!vR3(pt3, pt1)));
	double d3(sqrt(!vR3(pt4, pt1)));
	
	if(boundBox)
		delete boundBox;
	
	mass_center = pR3((maxx+minx)/2., (maxy+miny)/2., (maxz+minz)/2. );
	boundBox = new SBox(d2, d3, d1, Color(1., 0., 0.),mass_center );		
}
*/
bool SEntity::loadFromMyModel(Model& m)
{
	GLfloat minx(1000000.), miny(1000000.), minz(1000000.), maxx(-1000000.), maxy(-1000000.), maxz(-1000000.);
	GLfloat minxp(1000000.), minyp(1000000.), minzp(1000000.), maxxp(-1000000.), maxyp(-1000000.), maxzp(-1000000.);

	SEntity* brrr = this;
	if(allObj.size()>0)
	{
		for(list<SPerso*>::iterator it=allObj.begin();it!=allObj.end();it++)
			delete (*it);
		allObj.clear();
	}
	
	for(list<SPerso*>::iterator it=m.allObjM.begin();it!=m.allObjM.end();it++)
			allObj.push_back( new SPerso(**it) );

	for(list<SPerso*>::iterator it=allObj.begin();it!=allObj.end();it++)
	{
		(*it)->loadModel(minxp, minyp, minzp, maxxp, maxyp, maxzp);
		
		if(minxp < minx)
			minx = minxp;
		if(minyp < miny)
			miny = minyp;
		if(minzp < minz)
			minz = minzp;
		
		if(maxxp > maxx)
			maxx = maxxp;
		if(maxyp > maxy)
			maxy = maxyp;
		if(maxzp > minz)
			maxz = maxzp;
		
		minxp = minyp = minzp = 10000000.;
		maxxp = maxyp = maxzp = -10000000.;
	}
					
	pR3 pt1(minx, maxy, maxz), pt2(minx, maxy, minz),
	    pt3(maxx, maxy, maxz), 
	    pt4(minx, miny, maxz);
	
	double d1(sqrt(!vR3(pt1, pt2)));
	double d2(sqrt(!vR3(pt3, pt1)));
	double d3(sqrt(!vR3(pt4, pt1)));
	
	if(boundBox)
		delete boundBox;
	
	mass_center = pR3((maxx+minx)/2., (maxy+miny)/2., (maxz+minz)/2. );
	boundBox = new SBox(d2, d3, d1, Color(1., 0., 0.),mass_center );
	
	return true;	
}


	
void SEntity::updatePosition(const pR3& _p)
{
	pR3 dist(mass_center - _p);
	
	for(list<SPerso*>::iterator itobj=allObj.begin();itobj!=allObj.end();itobj++)
		(*itobj)->SPerso::updatePosition((*itobj)->getMassCenter() - dist);
	
	if(boundBox)
		boundBox->updatePosition(_p);
	
	mass_center = _p;	
}

void SEntity::resize(float facteur)
{
	double maximum(max(max(boundBox->getLong(), boundBox->getHeight()), boundBox->getWidth()));
	maximum = static_cast<double>(facteur) / maximum;
	
	for(list<SPerso*>::iterator itobj=allObj.begin();itobj!=allObj.end();itobj++)
		(*itobj)->resize(maximum);
	
	double last_l(boundBox->getLong() * maximum), last_h(boundBox->getHeight() * maximum), last_w(boundBox->getWidth() * maximum);
	
	pR3 mcenter = boundBox->getMassCenter();
	mcenter = mcenter*maximum;
	
	if(boundBox)
		delete boundBox;
	boundBox = new SBox(last_l, last_h, last_w, Color(1., 0., 0.), mcenter);
	
	mass_center = mcenter;
}



	


void SEntity::setAmbiantMaterial(int ind, const Color& col)
{
	if(ind < allObj.size() && ind >= 0)
	{
		list<SPerso*>::iterator it = allObj.begin();
		for(int i(0);i<ind;i++, it++);
		(*it)->matiere.setAmbiant(col);
	}
	else
		if(ind < 0)
			for(list<SPerso*>::iterator it = allObj.begin();it!= allObj.end(); it++)
				(*it)->matiere.setAmbiant(col);
}

void SEntity::setDiffuseMaterial(int ind, const Color& col)
{
	if(ind < allObj.size() && ind >= 0)
	{
		list<SPerso*>::iterator it = allObj.begin();
		for(int i(0);i<ind;i++, it++);
		(*it)->matiere.setDiffuse(col);
	}
	else
		if(ind < 0)
			for(list<SPerso*>::iterator it = allObj.begin();it!= allObj.end(); it++)
				(*it)->matiere.setDiffuse(col);
}

void SEntity::setSpecularMaterial(int ind, const Color& col)
{
	if(ind < allObj.size() && ind >= 0)
	{
		list<SPerso*>::iterator it = allObj.begin();
		for(int i(0);i<ind;i++, it++);
		(*it)->matiere.setSpecular(col);
	}
	else
		if(ind < 0)
			for(list<SPerso*>::iterator it = allObj.begin();it!= allObj.end(); it++)
				(*it)->matiere.setSpecular(col);
}




void SEntity::applyTransform(const Transform& mat_trans, bool maj_norm)
{
	list<SPerso*>::iterator it = allObj.begin();
	for(int i(0);i<allObj.size();i++, it++)
		(*it)->SPerso::applyTransform(mat_trans, maj_norm);
	
	mass_center = mat_trans * mass_center;
	boundBox->applyTransform(mat_trans);
}

void SEntity::setInitPos(const pR3& _p)
{
	pR3 dist(mass_center - _p);
	
	for(list<SPerso*>::iterator it = allObj.begin();it!= allObj.end(); it++)
		(*it)->setInitPos((*it)->getMassCenter() - dist);
	
	if(boundBox)
		boundBox->updatePosition(_p);
	
	mass_center = _p;	
}


/////////////////////////////////////////////// CLASSE SMONSTRE //////////////////////////////////////////////////

SMonstre::SMonstre() : SEntity(), life(100), armor(100)
{
	entity_pt = this;
	md2Mod    = NULL;
	tex	  = NULL;
}


SMonstre::SMonstre(Model& m) : SEntity(), life(100), armor(100)
{
	loadFromMyModel(m);
	
	entity_pt = this;
	tex	  = NULL;
}

SMonstre::~SMonstre()
{
	entity_pt = NULL;
	md2Mod    = NULL;
	tex 	  = NULL;
}

void SMonstre::Touched(float degat)
{
	if(armor>0.)
	{
		float tmp( armor-(0.8*degat) );
		float tmp2( life-(0.2*degat) );
		
		if( tmp>=0. )
		{
			armor=tmp;
			if( tmp2>0 )
				life=tmp2;
			else
				life=0.;
		}
		else
		{
			tmp=armor, armor=0;
			if( (degat-tmp) < 0. )
				life=0.;
			else
				life -= (degat-tmp);
		}
	}
	else
		if( (life-degat) <=0. )
			life=0.;
		else
			life-=degat;
}

bool SMonstre::IsAlive()
{
	return (life > 0);
}

void SMonstre::importMd2(Md2Model* mod, const char* fic_name)
{
	md2Mod = mod;
	
	if(mod)
	{
		SPerso* entit = new SPerso;
		frameMd2 *pFrame = &(mod->m_pFrames[0]);
		vec3_t v;
		GLfloat minx(1000000.), miny(1000000.), minz(1000000.), maxx(-1000000.), maxy(-1000000.), maxz(-1000000.);

		for( int i = 0; i < mod->m_kHeader.num_vertices; i++ )
        	{
			vertMd2  *pVert  = &pFrame->verts[i];
			
               		v.x = (pFrame->scale.x * pVert->v[0] + pFrame->translate.x) * mod->m_fScale;
                	v.y = (pFrame->scale.y * pVert->v[1] + pFrame->translate.y) * mod->m_fScale;
                	v.z = (pFrame->scale.z * pVert->v[2] + pFrame->translate.z) * mod->m_fScale;
			
			if(v.x < minx)
				minx = v.x;
			if(v.x > maxx)
				maxx = v.x;
			
			if(v.y < miny)
				miny = v.y;
			if(v.y > maxy)
				maxy = v.y;
			
			if(v.z < minz)
				minz = v.z;
			if(v.z > maxz)
				maxz = v.z;
		}
		
		pR3 pt1(minx, maxy, maxz), pt2(minx, maxy, minz);
		pR3 pt3(maxx, maxy, maxz), pt4(minx, miny, maxz);
	
		double d1(sqrt(!vR3(pt1, pt2))), d2(sqrt(!vR3(pt3, pt1))), d3(sqrt(!vR3(pt4, pt1)));
		
		entit->mass_center = pR3((maxx+minx)/2., (maxy+miny)/2., (maxz+minz)/2. );
		entit->boundBox = new SBox(d2, d3, d1, Color(1., 0., 0.), mass_center );
		
		allObj.push_back(entit);	// Maintient du SPerso (a revoir)

		mass_center = pR3((maxx+minx)/2., (maxy+miny)/2., (maxz+minz)/2. );
		boundBox = new SBox(d2, d3, d1, Color(1., 0., 0.), mass_center );
		
		md2Mod->setNormals(fic_name);
	}
}

void SMonstre::display() const
{
	frameMd2 *pFrame = NULL;
	vertMd2  *pVert  = NULL;
	vec3_t v;
	GLfloat tab_tmp[3];
	
	if(tex)
		tex->activer();
	
	glBegin(GL_TRIANGLES);

       	for( int i = 0; i < md2Mod->m_kHeader.num_tris; i++ )
        {
            for( int k = 0; k < 3; k++ )
            {
                pFrame = &(md2Mod->m_pFrames[0]);
                pVert  = &pFrame->verts[md2Mod->m_pTriangles[i].vertex[k]];

                GLfloat s = (GLfloat)md2Mod->m_pTexCoords[ md2Mod->m_pTriangles[i].st[k] ].s / md2Mod->m_kHeader.skinwidth;
                GLfloat t = (GLfloat)md2Mod->m_pTexCoords[ md2Mod->m_pTriangles[i].st[k] ].t / md2Mod->m_kHeader.skinheight;
		
                glTexCoord2f(s, t);

		memcpy(tab_tmp, &md2Mod->m_kAnorms[pVert->normalIndex], sizeof(float)*3);
		
                glNormal3fv( tab_tmp );

                v.x = (pFrame->scale.x * pVert->v[0] + pFrame->translate.x) * md2Mod->m_fScale;
                v.y = (pFrame->scale.y * pVert->v[1] + pFrame->translate.y) * md2Mod->m_fScale;
                v.z = (pFrame->scale.z * pVert->v[2] + pFrame->translate.z) * md2Mod->m_fScale;

		memcpy(tab_tmp, &v, sizeof(float)*3);
		
                glVertex3fv( tab_tmp );
            }
	}
	
	glEnd();
	
	if(tex)
		tex->activer();
}

void SMonstre::loadTexture(TextureGL* tex_base)
{
	tex = tex_base;
}

