// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */


#include <motor/sarme.hh>


SArme::SArme(SArmeType t) :inActionUp(false), inActionDown(false),fire(false)
{ 
	type=t;
	switch(t)
	{
		case MP40:
			
			nb_amo   = new short(31);	
			amo_caps = new short(31);
			cadence  = new GLfloat(1.0);
			amo_used = MP40_Amo;
			
		//	amo_type=new SAmo::SAmoType(amo_used->getType());
			cap_vise = 1.3;
			fact_porte = new GLfloat(1.0);
			break;
			
		case STEIGNER:	
			nb_amo   = new short(25);	
			amo_caps = new short(25);
			cadence  = new GLfloat(1.2);
			amo_used = STEIGNER_Amo;
			
			//amo_type=new SAmo::SAmoType(amo_used->getType());
			cap_vise = 1.5;
			fact_porte = new GLfloat(1.1);
			break;
			
		case BROWNING:
			nb_amo   = new short(13);	
			amo_caps = new short(13);
			cadence  = new GLfloat(0.5);
			amo_used = BROWNING_Amo;
			
			//amo_type=new SAmo::SAmoType(amo_used->getType());
			cap_vise = 0.75;
			fact_porte = new GLfloat(0.5);
			break;

		case AK47:
			nb_amo   = new short(21);	
			amo_caps = new short(21);
			cadence  = new GLfloat(1.5);
			amo_used = AK47_Amo;
			
			//amo_type=new SAmo::SAmoType(amo_used->getType());
			cap_vise=0.7;
			fact_porte=new GLfloat(0.7);
			break;
		case GRENADE:
			nb_amo   = new short(5);
			amo_caps = new short(5);
			cadence  = new GLfloat(1.5);
			amo_used = GRENADE_Amo;
			
			cap_vise = 0.7;
			fact_porte = new GLfloat(2.5);
			break;
	}	
	
}


SArme::~SArme()
{
	switch(type)
	{
		case MP40:
		case STEIGNER: 
		case BROWNING:
		case STERN:
		case GRENADE:
		case UZI:
		case AK47:
		case WPPK:
		
			if(nb_amo)
			delete nb_amo;

			if(amo_caps)	
			delete amo_caps;
			
			if( cadence)
			delete cadence;
			
/*			if(amo_type)
			delete amo_type;	*/	
			
			if(fact_porte)
			delete fact_porte;
		break;
	}
}

void SArme::Reload(short& stock,bool num)
{
	if(num)
	{
		switch(type)
		{
			case MP40:
			case STEIGNER: 
			case BROWNING:
			case GRENADE:
			case STERN:
			case UZI:
			case AK47:
			case WPPK:
				if( stock >0 )
					if( stock <= amo_caps[0] )
 					{
						nb_amo[0]=  stock ;
						stock=0;
					}
					else
					{
                            stock-=(amo_caps[0]-nb_amo[0]);
                            nb_amo[0]= amo_caps[0] ;
                    }
			break;
		}
	}	
}		

void SArme::Fire( short& nb_rech, bool isActiv, bool num)
{
	
	if(nb_amo)
		if( nb_amo[0] > 0 )
		{
			nb_amo[0]--;
			inActionUp   = isActiv;
			inActionDown = !isActiv;
			fire	     = isActiv;
		}
		else
			Reload(nb_rech,num);
	
}

void SArme::Viser()
{}		
		
GLfloat SArme::getVise()const
{}

short SArme::getNbAmo(bool num)const
{	if(num)
		return nb_amo[0];
	else
		return (nb_amo[1]) ? nb_amo[1]: nb_amo[0] ;

}
		
short SArme::getAmoCaps(bool num)const
{

	if(num)
		return amo_caps[0];
	else
		return (amo_caps[1]) ? amo_caps[1]: amo_caps[0];
}

GLfloat SArme::getCadence(bool num)const
{}
		
SAmo::SAmoType SArme::getAmoType(bool num) const
{}		

SArme::SArmeType SArme::getArmeType() const
{
	return type;
}






SAmo::SAmo(SAmoType _type,SpecAmoType t):type(_type),specType(t)
{
	switch(type)
	{
		case NINE_MM:
			porte= 150.0; // en metre ???
			break;
	}		
}

SAmo::SAmo(const SAmo& _src):type(_src.type),specType(_src.specType),porte(_src.porte)
{}


SAmo::~SAmo()
{}		
		
SAmo::SAmoType SAmo::getType()const
{return type;}

GLfloat SAmo::getPorte()const
{return porte;}

GLfloat SAmo::getSpecAmoType()const
{return specType;}

void SAmo::setSpecAmoType(SpecAmoType t)
{specType=t;}



SAmoStock::SAmoStock(): NB_NINE_MM(500),
			NB_C12(0),
			NB_PANZER(0),
			NB_GREN(100),
			NB_P50(0),
			NB_SEVEN65(0)
{}


SAmoStock::~SAmoStock()
{}
