// Copyright (C) 2006 Seb_le_Ouf&Snake.
/*  
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.
   
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
   
      You should have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
      
 */
 
 

#include <stdlib.h>
#include <unistd.h>
#include <list>
#include <signal.h>
#include <iostream>


#include <network/serveur.hh>
#include <network/paquet_serv.hh>

using namespace std;

/*		Functions called by pthread_cleanup_push/pop		*/
void my_delete_paq(void* arg)
{	delete (Paquet*)arg;	}


void my_close(void* arg)
{	close((int)arg );	} 
/**********************************************************************/


Serveur::Serveur():all_cli(),id_cour(0),port(10001)
{
	mut_cli=new pthread_mutex_t();
	pthread_mutex_init(mut_cli,NULL);
	mutex_thread=new pthread_mutex_t();
	pthread_mutex_init(mutex_thread,NULL);
	mutex_id=new pthread_mutex_t();
	pthread_mutex_init(mutex_id,NULL);
	
   #ifdef WIN32
	WSADATA WSAData;
	WSAStartup(MAKEWORD(2,0), &WSAData);
   #else
	signal (SIGINT, Serveur::rec_sig);
	signal (SIGSEGV, Serveur::rec_sig);
   #endif
	memset (&adresse, 0, sizeof (struct sockaddr_in));
// 	adresse.sin_addr.s_addr	= inet_addr("10.0.0.3");
   #ifndef WIN32
	if( inet_aton("10.0.0.3",&(adresse.sin_addr))==0 )
   #else
   	if( (adresse.sin_addr.s_addr = inet_addr("10.0.0.3")) == INADDR_NONE )
   #endif	
		cout<<"err aton"<<endl;

	adresse.sin_family	      = AF_INET;
	adresse.sin_port	      = htons(port);
}

Serveur::Serveur(const int& _port):all_cli(),id_cour(0),port(_port)
{
	mut_cli=new pthread_mutex_t();
	pthread_mutex_init(mut_cli,NULL);
	mutex_thread=new pthread_mutex_t();
	pthread_mutex_init(mutex_thread,NULL);
	mutex_id=new pthread_mutex_t();
	pthread_mutex_init(mutex_id,NULL);
	
   #ifdef WIN32
	WSADATA WSAData;
	WSAStartup(MAKEWORD(2,0), &WSAData);
   #else
	signal (SIGINT, Serveur::rec_sig);
	signal (SIGSEGV, Serveur::rec_sig);
   #endif
	memset (&adresse, 0, sizeof (struct sockaddr_in));
// 	adresse.sin_addr.s_addr	= inet_addr("10.0.0.3");
	if( inet_aton("10.0.0.3",&(adresse.sin_addr))==0 )
		cout<<"err aton"<<endl;
	//adresse.sin_addr.s_addr	= inet_addr("pcemilie");
	adresse.sin_family	      = AF_INET;
	adresse.sin_port	      = htons(port);
}


Serveur::~Serveur()
{
	pthread_mutex_lock(mut_cli);
	for(list<Client*>::iterator it=all_cli.begin(); it!=all_cli.end();it++)
		delete *it;
	
	all_cli.clear();
	pthread_mutex_unlock(mut_cli);
   	pthread_mutex_destroy(mut_cli);
	delete mut_cli;

	pthread_mutex_lock(mutex_thread);
	for(list<pthread_t>::const_iterator it=threads.begin(); it!=threads.end();it++)
		pthread_detach( *it );
	threads.clear();    
	pthread_mutex_unlock(mutex_thread);
	pthread_mutex_destroy(mutex_thread);
	delete mutex_thread;

	pthread_mutex_destroy(mutex_thread);
	delete mutex_id;
}


bool Serveur::init()
{
	if ( (sock = socket (AF_INET, SOCK_STREAM, 0) ) < 0)
	{
		cout<<"Err socket :"<<endl;             
		perror ("socket");
		return false;
	}

	if (bind (sock, (struct sockaddr *) &adresse, sizeof (struct sockaddr_in)) < 0)
	{
		cout<<"Err bind :"<<endl;	   
		perror ("bind");
		return false;
	}

	if (listen (sock, 5) < 0)
	{
		cout<<"Err listen :"<<endl;		  
		perror ("listen");
		return false;
	}
	
	cout<<endl<<"Multiplayer server for FPS 1.1 by Seb__Ouf and Snake51 :"<<endl;
	cout<<"Listening on IP "<<inet_ntoa(adresse.sin_addr)<<" on port "<<port<<" ..."<<endl<<endl;
	return true;
}

bool Serveur::start()
{
	int nouvelle;
	struct sockaddr_in adresse_client;
	while (1)
	{
		if( sigsetjmp(contexte,1)!=0 ) // Si on arrive par le saut (signal recu), on quitte la boucle
			break;
	#ifdef WIN32   
		int longu = sizeof (struct sockaddr_in);
	#else	  
		socklen_t longu = sizeof (struct sockaddr_in);
	#endif     
		nouvelle = accept (sock, (struct sockaddr *) &adresse_client, &longu);

	#ifdef WIN32     
      		if(nouvelle != INVALID_SOCKET)
	#else 
		if(nouvelle > 0)
	#endif      
		{
			pthread_t *t=new pthread_t();
			int ret;
			pthread_mutex_lock(mutex_id);
			Client *tmp_cli=new Client(id_cour++,nouvelle);
			pthread_mutex_unlock(mutex_id);
			transmis tr;
			tr._cli=tmp_cli;
			tr._serv=this;

			if ( (ret= pthread_create(t,NULL,Create_Thread,(void*)&tr ))!=0)
			{  
				cout<<"err create_thread"<<endl;
				close(nouvelle);
				continue;
			}
			else
			{
				pthread_mutex_lock(mutex_thread);
				threads.push_back(*t);
				pthread_mutex_unlock(mutex_thread);
			}
      		}
		else
		{
			cout<<"Err accept :"<<endl;                   
			perror ("accept");
			continue;
		}
	}
	cout<<"Stop listening"<<endl;
	_close();
	return true;
}

void Serveur::_close()
{
	close(sock);
	cout<<"Connection closed"<<endl;
	#ifdef WIN32
	WSACleanup();
	#endif
}
void Serveur::stop()
{
	cout<<"Stop requested"<<endl;
 	siglongjmp(contexte,1);
}

void Serveur::add(float _id,int _sock)
{
	pthread_mutex_lock(mut_cli);
 	all_cli.push_back(new Client(_id,_sock));
	pthread_mutex_unlock(mut_cli);     
}

void Serveur::del(float _id)
{
	pthread_mutex_lock(mut_cli);
	for(list<Client*>::iterator it=all_cli.begin(); it!=all_cli.end();it++)
	{
		if( (*it)->ID == _id )
		{       	
			delete (*it);
			it=all_cli.erase(it);
		}
	}     
	pthread_mutex_unlock(mut_cli); 
}


void* Serveur::Create_Thread(void* cli)
{
	transmis *tr=reinterpret_cast<transmis*>(cli);
	Client *aa=tr->_cli;
	Serveur* ser=tr->_serv ;
 	cout<<"fils= "<<aa->ID<<endl;
	
	Paquet *paq=new Paquet(ser,aa->ID);
	
	pthread_cleanup_push(my_delete_paq ,(void*) paq );
	
	while( paq->receive(aa->Sock)!=false );
		
	pthread_cleanup_pop(1); //delete paq;    
	pthread_exit(NULL);
	return NULL;
}
              

/*		GETTERS		*/

const int Serveur::getSocket(float _id)const
{
	int ret(-1);
	pthread_mutex_lock(mut_cli);

	for(list<Client*>::const_iterator it=all_cli.begin(); it!=all_cli.end();it++)
		if( (*it)->ID == _id )
			ret= ((*it)->Sock);

	pthread_mutex_unlock(mut_cli);
	return ret;  
}

pthread_mutex_t* Serveur::getMutex(float _id)const
{
	pthread_mutex_t* ret=NULL;

	pthread_mutex_lock(mut_cli);
	list<Client*>::const_iterator it=all_cli.begin();
	for(; it!=all_cli.end();it++)
		if( (*it)->ID == _id )
		{
			ret= ((*it)->Sock_mutex);
			break;
		}
	pthread_mutex_unlock(mut_cli);
	return ret;
}

const list<int> Serveur::getAllOtherSock(float _id)const
{
	pthread_mutex_lock(mut_cli);
	list<int> tmp_socks;
	for(list<Client*>::const_iterator it=all_cli.begin(); it!=all_cli.end();it++)
		if( (*it)->ID != _id )
			tmp_socks.push_back( (*it)->Sock );
	pthread_mutex_unlock(mut_cli);	
	return tmp_socks;
}


const list<float> Serveur::getAllID()const
{
	pthread_mutex_lock(mut_cli);
	list<float> tmp_socks;
	for(list<Client*>::const_iterator it=all_cli.begin(); it!=all_cli.end();it++)
		tmp_socks.push_back( (*it)->Sock );
	pthread_mutex_unlock(mut_cli);	
	return tmp_socks;
}

/*********************************************************************/
